//----------------------------------------------------------
//	Copyright (C) Siemens AG (1998). All Rights Reserved
//	Product:      SIMATIC PDM
//
//	Device:			Mettler-Toledo Cond 7100e /2(X)H
//	Description:	Device Description
//	Dictionary:		SIPADC01.dct, MT__STTA.dct
//	Copyright:		Mettler Toledo GmbH,
//					Process Analytics
//					P.O.Box
//					8902 Urdorf
//					Switzerland
//
//	Date:			08.03.2005 
//----------------------------------------------------------

MANUFACTURER	142,	// Mettler
DEVICE_TYPE		120,	// Cond 7100e / 2(X)H
DEVICE_REVISION 2,
DD_REVISION		1


/*-------------------Nur ein Zielsystem whlen---------------*/
/* Entweder AMS,  PDM oder HC275 							 */
/*-----------------------------------------------------------*/

/*#define AMS*/
#define PDM 
/* #define HC275 */

/*-----------------------------------------------------------*/

#ifdef AMS
#define AMS_PDM
#endif

#ifdef PDM
#define AMS_PDM
#define PDM_bool true
#else
#define PDM_bool false
#endif

#include "SI_HlpM.inc"
#include "SIHASTIDENT01.inc"


#define STATUS_SIZE		3	  // muss unbedingt definiert sein, HCF275 benoetigt dies nicht aber PDM schon!, sonst koennen keine char [STATUS_SIZE] interpretiert werden
#define STATUS_RESPONSE_CODE	0	 							   
#define STATUS_COMM_STATUS	1
#define STATUS_DEVICE_STATUS	2
																						

#define UNIT_SAL		"g/kg"
#define UNIT_CELL		"1/cm"
#define UNIT_TC_LIN		"%/K"
#define UNIT_TEMP_C		"C"
#define UNIT_TEMP_F		"F"
#define UNIT_US			"S"
#define UNIT_MS			"mS"
#define UNIT_SM         "Sm"
#define UNIT_PERC		"%"
#define UNIT_MA			[mA]
#define UNIT_SEC	    "s";

#define UNITS_CODE_US		56
#define UNITS_CODE_OHM		37		
#define UNITS_CODE_TEMP_C	32
#define UNITS_CODE_TEMP_F	33
#define UNITS_CODE_SEC		51
#define UNITS_CODE_PERC		57
#define UNITS_CODE_MA		39
#define UNITS_CODE_TC_LIN	243
#define UNITS_CODE_SAL		246
#define UNITS_CODE_NON		251

#define ALL_UNITS        UNITS_CODE (UNITS_CODE_OHM), UNITS_CODE (UNITS_CODE_US), \
						 UNITS_CODE (UNITS_CODE_TEMP_C), UNITS_CODE (UNITS_CODE_TEMP_F), \
						 UNITS_CODE (UNITS_CODE_MA), UNITS_CODE (UNITS_CODE_PERC), \
						 { UNITS_CODE_TC_LIN, UNIT_TC_LIN }, { UNITS_CODE_SAL, UNIT_SAL }

#define USED_UNITS      UNITS_CODE (UNITS_CODE_OHM), UNITS_CODE (UNITS_CODE_US), UNITS_CODE (UNITS_CODE_PERC)
#define TEMP_UNITS      UNITS_CODE (UNITS_CODE_TEMP_C), UNITS_CODE (UNITS_CODE_TEMP_F)

#define DISPLAY_SAL			"4.1f";
#define DISPLAY_TEMP_C		"5.1f";
#define DISPLAY_TEMP_F		"5.0f";
#define DISPLAY_CURR		"4.1f";
#define DISPLAY_PERC		"5.1f";
#define DISPLAY_CONC		"5.1f";
#define DISPLAY_SEC		    "5.1f";

/* Transmittervariablen */


#define transvar_cond 		0
#define transvar_conc		1
#define transvar_temp   	2
#define transvar_sal		3 
#define transvar_cond_oTC	4 
#define transvar_curr		8
#define transvar_perc		9
#define transvar_input 		10
#define transvar_tc			11
#define transvar_tc_lin		12
#define transvar_lin_log	13
#define transvar_curr_lrv	14
#define transvar_curr_urv	15
#define transvar_diag		16
#define transvar_cell		17
#define transvar_zero		18
#define transvar_sfc		19
#define transvar_output		20
#define transvar_fix_value	21

/* Stratos e */
#define transvar_sample_cal	    30
#define transvar_filter_1    	31
#define transvar_alarmdelay_1	32
#define transvar_conf_4 		33
#define transvar_sel_sensor 	34

/*------------------------------------------------------------------------------------*/

#define selected_pv_enum      \
	TYPE ENUMERATED{          \
    IF (!e2212){              \
			{ 0, "00.00 mS"}, \
			{ 1, "000.0 mS"}, \
			{ 2, " 0000 mS"}, \
			{ 3, [Percent] }, \
			{ 4, "SAL" }      \
	}ELSE{                    \
            { 5, "0.000 mS"}, \
            { 0, "00.00 mS"}, \
			{ 1, "000.0 mS"}, \
			{ 2, " 0000 mS"}, \
			{ 3, [Percent] }, \
			{ 4, "SAL" },     \
            { 6, "0.000 Sm"}, \
            { 7, "00.00 Sm"} \
    }}



#define selected_pv_meth \
		"00.00 mS;000.0 mS;0000 mS;000.0 %;000.0 SAL"

#define selected_pv_meth_e \
		"00.00 mS;000.0 mS;0000 mS;000.0 %;000.0 SAL;0.000 mS;0.000 Sm;00.00 Sm"

/*------------------------------------------------------------------------------------*/

#define selected_conc_sol_enum      \
	TYPE ENUMERATED {          \
        IF (!e2212){           \
			{ 0, "NaCl"},      \
			{ 1, "HCl"},       \
			{ 2, "NaOH"},      \
			{ 3, "H2SO4 (1)"}, \
			{ 4, "HNO3"},      \
			{ 5, "H2SO4 (3)"}  \
        }ELSE{                 \
			{ 0, "NaCl"},      \
			{ 1, "HCl (1)"},   \
			{ 2, "NaOH (1)"},  \
			{ 3, "H2SO4 (1)"}, \
			{ 4, "HNO3 (1)"},  \
			{ 5, "H2SO4 (3)"}  \
		    { 6, "HCl (2)"}    \
            { 7, "HNO3 (2)"}   \
		    { 8, "H2SO4 (2)"}  \
            { 9, "NaOH (2)"}   \
        }                      \
	}

#define selected_conc_sol_meth   "NaCl;HCl;NaOH;H2SO4 (1);HNO3;H2SO4 (3)"
#define selected_conc_sol_meth_e "NaCl;HCl (1);NaOH (1);H2SO4 (1);HNO3 (1);H2SO4 (3);HCl (2);HNO3 (2);H2SO4 (2);NaOH (2)"

/*------------------------------------------------------------------------------------*/

#define selected_temp_unit_enum   \
	TYPE ENUMERATED{              \
			 { 0, UNIT_TEMP_C } , \
			 { 1, UNIT_TEMP_F }   \
	}

#define selected_temp_unit_meth "C;F"

/*------------------------------------------------------------------------------------*/

#define selected_temp_sensor_enum \
	TYPE ENUMERATED{              \
			 { 0, "Pt100"},       \
			 { 1, "Pt1000"},      \
			 { 3, "NTC30k"},      \
             { 2, "NTC100k"}      \             
	}     

#define selected_temp_sensor_meth "Pt100;Pt1000;NTC100k;NTC30k"

/*------------------------------------------------------------------------------------*/

#define selected_tc_enum          \
	TYPE ENUMERATED{              \
			 { 0, "OFF"},         \
			 { 1, "LIN"},         \
			 { 2, "NLF"}          \
	}
#define selected_tc_meth "OFF;LIN;NLF"

/*------------------------------------------------------------------------------------*/

#define selected_lin_log_enum     \
	TYPE ENUMERATED{              \
			 { 0, "Lin"},         \
			 { 1, "Log"}          \
	}

#define selected_lin_log_meth "Lin;Log"

/*------------------------------------------------------------------------------------*/

#define selected_log_enum 		          \

#define selected_log_meth "0.1 mS;1.000 mS;10.00 mS;100.0 mS;1000 mS"
#define selected_log_meth_e "0.1 mS;1.000 mS;10.00 mS;100.0 mS;1000 mS"


/*------------------------------------------------------------------------------------*/

#define selected_off_on_enum 	\
	TYPE ENUMERATED{ 			\
			 { 0, "Off"}, 		\
			 { 1, "On "}        \
	}
#define selected_off_on_meth "Off;On"

/*------------------------------------------------------------------------------------*/

#define sel_hl0	"Last value" "|de|Letzter Wert"
#define sel_hl1	"Fixed Current"	"|de|Festwert"
#define selected_hold_last_fix_enum	TYPE ENUMERATED{ { 0, sel_hl0 }, { 1, sel_hl1 } }
#define selected_hold_last_fix_meth	sel_hl0 ";" sel_hl1

/*------------------------------------------------------------------------------------*/

#define selected_sensor_enum \
	TYPE ENUMERATED{ 		 \
			 { 0, "InPro7250"} ,\
             { 4, "Other"}      \
	}



/*------------------------------------------------------------------------------------*/

#define def_unit_type                           \
    CONSTANT_UNIT IF (!e2212){                  \
    SELECT (selected_pv_unit){                  \
			    CASE 0: UNIT_MS ;               \
			    CASE 1: UNIT_MS ;	            \
			    CASE 2: UNIT_MS ;	            \
			    CASE 3: UNIT_PERC ;	            \
			    DEFAULT: UNIT_SAL ; }           \
        }ELSE{                                  \
                SELECT (selected_pv_unit){      \
			    CASE 0: UNIT_MS ;               \
			    CASE 1: UNIT_MS ;	            \
			    CASE 2: UNIT_MS ;	            \
			    CASE 3: UNIT_PERC ;	            \
			    CASE 4: UNIT_SAL ;	            \
			    CASE 5: UNIT_MS ;	            \
			    CASE 6: UNIT_SM ;	            \
			    DEFAULT: UNIT_SM ; }            \
        }                                       \
	TYPE FLOAT{ SCALING_FACTOR                  \
        IF (!e2212){                            \
		  SELECT (selected_pv_unit){            \
		    CASE 0: 1.0e-3 ;	                \
			CASE 1: 1.0e-3 ;	                \
			CASE 2: 1.0e-3 ;	                \
			CASE 3: 1 ;	                        \
			DEFAULT: 1 ; }	                    \
        }ELSE{                                  \
		  SELECT (selected_pv_unit){            \
		    CASE 0: 1.0e-3 ;	                        \
			CASE 1: 1.0e-3 ;	                        \
			CASE 2: 1.0e-3 ;	                        \
			CASE 3: 1 ;	                        \
			CASE 4: 1 ;                         \
			CASE 5: 1.0e-3 ;                    \
			CASE 6: 0.0001 ;                    \
			DEFAULT: 0.0001 ; }	                \
        }                                       \
        DISPLAY_FORMAT                          \
          IF (!e2212){                          \
            SELECT (selected_pv_unit){          \
		      CASE 0: "5.2f" ;	                \
		      CASE 1: "5.1f" ;	                \
			  CASE 2: "5.1f" ;	                \
			  CASE 3: DISPLAY_PERC              \
			  DEFAULT: DISPLAY_SAL}             \
        }ELSE{                                  \
            SELECT (selected_pv_unit){          \
		      CASE 0: "5.2f" ;	                \
		      CASE 1: "5.1f" ;	                \
			  CASE 2: "5.1f" ;	                \
			  CASE 3: DISPLAY_PERC  	        \
			  CASE 4: DISPLAY_SAL               \
			  CASE 5: "5.3f" ;	                \
			  CASE 6: "5.3f" ;	                \
              DEFAULT: "5.2f";}                 \
              }                                 \
     

/*------------------------------------------------------------------------------------*/

#define pv_unit_type def_unit_type }

#define output_unit_type def_unit_type \
        MIN_VALUE 0.0; \
		MAX_VALUE IF (!e2212){\
                SELECT (selected_pv_unit){ \
			    CASE 0: 9.999   ;	\
			    CASE 1: 999.9   ;	\
			    CASE 2: 1999    ;	\
			    CASE 3: 100.0   ;	\
			    DEFAULT:  45.0  ; } \
            }ELSE{                   \
                SELECT (selected_pv_unit){ \
			    CASE 0: 9.999   ;	\
			    CASE 1: 999.9   ;	\
			    CASE 2: 1999    ;	\
			    CASE 3: 100.0   ;	\
			    CASE 4: 45.0    ;	\
			    CASE 5: 9.999   ;	\
			    CASE 6: 99.99   ;	\
			    DEFAULT: 99.999 ;   \
            }\
            }}\


/*------------------------------------------------------------------------------------*/

#define cond_unit_type                   \
 	CONSTANT_UNIT IF (!e2212){           \
         SELECT (selected_pv_unit){      \
	 	    CASE 0: UNIT_MS ;            \
			CASE 1: UNIT_MS ;	         \
			DEFAULT: UNIT_MS ; }	     \
         }ELSE{                          \
         SELECT (selected_pv_unit){      \
	 	    CASE 0: UNIT_MS ;            \
			CASE 1: UNIT_MS ;    	     \
			CASE 2: UNIT_MS ;            \
			CASE 5: UNIT_MS ;   	     \
			CASE 6: UNIT_MS ;   	     \
			DEFAULT: UNIT_MS ;           \
         }}                              \
        TYPE FLOAT{                      \
		    SCALING_FACTOR IF (!e2212){  \
              SELECT (selected_pv_unit){ \
		        CASE 0: 1.0e-3 ;         \
		    	CASE 1: 1.0e-3 ;         \
		    	DEFAULT: 1.0e-3 ; }      \
              }ELSE{                     \
              SELECT (selected_pv_unit){ \
		        CASE 0: 1.0e-3 ;	     \
		    	CASE 1: 1.0e-3 ;	     \
		    	CASE 2: 1.0e-3 ;	     \
                CASE 5: 1.0e-3 ;	     \
                CASE 6: 1.0e-3 ;	     \
		    	DEFAULT: 1.0e-3 ; }           \
              }                          \
              DISPLAY_FORMAT	IF(!e2212){  \
                SELECT (selected_pv_unit){ \
		            CASE 0: "5.2f" ; \
		    	    CASE 1: "5.1f" ; \
		    	    DEFAULT:"4.0f" ; }\
               }ELSE{\
                    SELECT (selected_pv_unit){ \
		            CASE 0: "5.2f" ; \
		    	    CASE 1: "5.1f" ; \
		    	    CASE 2: "4.0f" ; \
		    	    CASE 5: "5.3f" ; \
		    	    CASE 6: "5.3f" ; \
                    DEFAULT:"5.2f" ; }\
               }\
}





/*------------------------------------------------------------------------------------*/

#define sv_unit_type \
	CONSTANT_UNIT   IF (sv_temp_units == UNITS_CODE_TEMP_C) { UNIT_TEMP_C; }ELSE{ UNIT_TEMP_F; } \
   TYPE FLOAT{     DISPLAY_FORMAT IF (sv_temp_units == UNITS_CODE_TEMP_C) { DISPLAY_TEMP_C }ELSE{ DISPLAY_TEMP_F } }


/*------------------------------------------------------------------------------------*/


/**/
/*                                                                                                            */
/*      SSSS  TTTTT  RRRR    AAA   TTTTT   OOO    SSSS        EEEEE                                           */
/*     S        T    R   R  A   A    T    O   O  S            E                                               */
/*      SSS     T    RRRR   AAAAA    T    O   O   SSS         EEEE                                            */
/*         S    T    R  R   A   A    T    O   O      S        E                                               */
/*     SSSS     T    R   R  A   A    T     OOO   SSSS         EEEEE                                           */
/*                                                                                                            */
/**/

#define e2212_HW_rev			2


#define e2212					(hardware_revision >= e2212_HW_rev) 

#define e2212_meth				(int_value( hardware_revision ) >= e2212_HW_rev)


#define x2212( _new, _old ) 	IF( e2212 ){ _new }ELSE{ _old }	

#define valid_2211				VALIDITY x2212( FALSE;, TRUE; ) 
#define valid_2212				VALIDITY x2212( TRUE;, FALSE; ) 


//=============================================================================
//  VARIABLEN
//=============================================================================

VARIABLE response_code		// Standard-Variable
{
  LABEL	[response_code];
  HELP	[command_specific_response_code_help];
  CLASS USER_INTERFACE & DIAGNOSTIC;
  HANDLING READ;
  TYPE ENUMERATED {
    {  0, [success] },
    {  1, [undefined] },
    {  2, [invalid_selection] },
    {  3, [passed_parameter_too_large] },
    {  4, [passed_parameter_too_small] },
    {  5, [too_few_data_bytes_recieved] },
    {  6, [xmtr_specific_command_error] },
    {  7, [in_write_protect_mode] },
    {  8, [xmtr_specific_command_error] },
    {  9, [xmtr_specific_command_error] },
    { 10, [xmtr_specific_command_error] },
    { 11, "Invalid Transmitter Variable" },
    { 12, "Invalid Unit Code" },
    { 13, [xmtr_specific_command_error] },
    { 14, [xmtr_specific_command_error] },
    { 15, [xmtr_specific_command_error] },
    { 16, [access_restricted] },
    { 32, [busy] },
    { 64, [command_not_implemented] }
  }
}

//-------------------------------------

VARIABLE device_status		// Standard-Variable
{
  LABEL	[device_status] ;
  HELP	[field_device_status_help];
  CLASS HART & DYNAMIC & DIAGNOSTIC;
  HANDLING READ;
  TYPE BIT_ENUMERATED {
    { 0x00, [no_error], MISC },
    { 0x01, "Primary variable outside limits"	"|de|Hauptvariable auerhalb Bereich", DV1 (AUTO & BAD) },
    { 0x02, "Temperature outside limits"	"|de|Nebenvariable auerhalb Bereich", DV2 (AUTO & BAD) },
    { 0x04, "Output outside operating range"	"|de|Ausgang auerhalb Mebereich",    AO1 (AUTO & BAD) },
    { 0x08, "Output in fixed mode"		"|de|Ausgang ist auf Festwert",	       AO1 (MANUAL & GOOD) },
    { 0x10, "More Status available"		"|de|Gert hat mehr Informationen",    MORE },
    { 0x20, "Device cold start"			"|de|Feldgert Kaltstart",	       MISC },
    { 0x40, "Configuration has been changed"	"|de|Konfiguration wurde verndert",   MISC & IGNORE_IN_HANDHELD },
    { 0x80, "Device malfunction or failure"	"|de|Gertefehlern oder Ausfall",      MORE}
  }
}


VARIABLE xmtr_specific_status_0 
{
	LABEL	"Error Status""|de|Fehlerzustnde" ;
	HELP   	"Field Device Error Status- Failure messages of the Field Device are listed" "|de|Feldgertfehlermeldungen";
    STYLE "MULTILINE 12 4";	 
	 TYPE		BIT_ENUMERATED {

			{ 0x01, "Err 01 Sensor" "|de|Err 01 Sensor-Fehler", DV1 (AUTO & BAD) } ,
			{ 0x02, "Err 02 Unsuitable Sensor" "|de|Err 02 ungeeigneter Sensor", DV1 (AUTO & BAD) } ,
			{ 0x04, "Err 03 Temp Value" "|de|Err 03 Temperaturfhler", TV1 (AUTO & BAD) } ,
			{ 0x08, "Err 11 Loop < 3.8mA" "|de|Err 11 Stromausgang < 3,8 mA", AO1 (AUTO & BAD) } ,
			{ 0x10, "Err 12 Loop >20.5mA" "|de|Err 12 Stromausgang > 20.5 mA", AO1 (AUTO & BAD) } ,
			{ 0x20, "Err 13 Loop Span" "|de|Err 13 Stromspanne zu klein / zu gro", DATA } ,
			{ 0x40, "Err 98 Config Data" "|de|Err 98 Systemfehler", HARDWARE } ,
			{ 0x80, "Err 99 Data Lost" "|de|Err 99 Abgleichdaten defekt", HARDWARE }	}
}

/*
VARIABLE xmtr_specific_status_1 
{
	 LABEL	"Smiley Earnest" "|de|Smiley ernst" ;
	 HELP	"Smiley Earnest - Maintance required. Sensoface provides information on wear and required maintance. However, device continues operation with diminished accuracy." 
	        "|de|Smiley ernst - Wartung erforderlich! Sensoface gibt Hinweise zum Zustand Ihrer Mekette.";
	 STYLE "MULTILINE 12 3";
	 TYPE		BIT_ENUMERATED {

			{ 0x01, "Electrode adjusts slowly. Clean electrode, soak it in buffer for hours"
					"|de|Elektrode sollte neu justiert werden. Subern Sie Elektrode, trnken Sie sie einige Stunden lang in einer Pufferlsung", PROCESS & IGNORE_IN_HANDHELD } ,
			{ 0x02, "Over 80% of the calibration interval has already past" "|de|ber 80% des Kalbriertimerintervals abgelaufen", PROCESS & IGNORE_IN_HANDHELD } ,
			{ 0x10, "Zero point or slope are still okay, however cleaning is recommended" 
					"|de|Nullpunkt und Steilheit der Elektrode sind noch in Ordnung. Ein Austausch sollte jedoch bald erfolgen", PROCESS & IGNORE_IN_HANDHELD }
		 }
} */


VARIABLE xmtr_specific_status_2 {
	LABEL 	"Smiley Sad""|de|Smiley traurig" ;
	HELP  	"Smiley Sad - Correct measurment is no longer ensured. Sensoface provides information on wear and required maintance. However, device continues operation with seriously diminished accuracy."
			"|de| Smiley traurig - Eine korrekte Messung wird nicht mehr gewhrleistet!  Sensoface gibt Hinweise zum Zustand Ihrer Mekette.";
    STYLE "MULTILINE 12 3";
	TYPE  	BIT_ENUMERATED {

			{ 0x04, "Err 33 primary coil" "|de|Err 33 Sendespule", PROCESS & IGNORE_IN_HANDHELD } ,
			{ 0x40, "Err Cell factor" "|de|Zellfaktor auerhalb des Bereiches", PROCESS & IGNORE_IN_HANDHELD }
            { 0x02, "Concentration temp" "|de|Temperatur fr Konzentration auerhlalb des Bereiches", PROCESS & IGNORE_IN_HANDHELD } ,
            { 0x08, "Err 34 secondary coil" "|de|Err 34 Empfangsspule",   PROCESS & IGNORE_IN_HANDHELD },
            { 0x10, "SAL temp" "|de|Temperatur fr Salinitt auerhalb des Bereiches", PROCESS & IGNORE_IN_HANDHELD },
            { 0x20, "zero point" "|de|Nullpunkt nicht mehr zulssig", PROCESS & IGNORE_IN_HANDHELD },
            { 0x80, "TC temp" "|de|Temperatur fr die Kompensation auerhalb des Bereiches", PROCESS & IGNORE_IN_HANDHELD }

		 }
		}


VARIABLE analog_output_saturated1 {
 	 TYPE  BIT_ENUMERATED {
			{ 0x01, "Analog Out Saturated" "|de|Analoge Ausgang befindet sich in Sttigung", AO1 (AUTO & BAD) }
	 }
}



VARIABLE analog_output_fixed1 {
	LABEL "HOLD Mode" "|de|Hold Modus" ;
	HELP  "Analog Outputs of the Field Device are fixed in HOLD mode. The analog and digital Outputs remain unchanged." 
		  "|de|Der Analoge Ausgang des Feldgertes befindet sich im HOLD-Modus." ;
	TYPE  BIT_ENUMERATED{
						{ 0x01, "HOLD Mode" "|de|HOLD-Modus", AO1 (MANUAL & GOOD) }
	}
}

//-------------------------------------

VARIABLE tag
{
  LABEL	[tag];
  HELP	[tag_help];
  CLASS DEVICE;
  TYPE PACKED_ASCII(8); 
  HANDLING READ & WRITE;
}

//-------------------------------------

VARIABLE descriptor
{
  LABEL	[descriptor];
  HELP	[discriptor_help];
  CLASS DEVICE;
  TYPE PACKED_ASCII(16); 
  HANDLING READ & WRITE;
}

//-------------------------------------

VARIABLE message
{
  LABEL	[message];
  HELP	[message_help];
  CLASS DEVICE;
  TYPE PACKED_ASCII(32);
  HANDLING READ & WRITE;
}

//-------------------------------------

VARIABLE manufacturer_id
{
  LABEL	[manufacturer_id];
  HELP	[manufacturer_id_code_help];
  HANDLING READ;
  CLASS HART;
  TYPE ENUMERATED {
    DEFAULT_VALUE 142;
    { 142, "Mettler Toledo" }
  }
}

//-------------------------------------

VARIABLE universal_revision
{
  LABEL	[universal_revision];
  HELP	[universal_revision_help];
  HANDLING READ;
  CLASS HART; 
  TYPE UNSIGNED_INTEGER { MAX_VALUE 253; }
}

//-------------------------------------

VARIABLE transmitter_revision
{
  LABEL	[transmitter_revision];
  HELP	[field_device_revision_help];
  HANDLING READ;
  CLASS HART; 
  TYPE UNSIGNED_INTEGER { MAX_VALUE 253; }
}

//-------------------------------------

VARIABLE software_revision
{
  LABEL	[software_revision];
  HELP	[field_device_software_revision_help];
  HANDLING READ;
  CLASS DEVICE;
  TYPE UNSIGNED_INTEGER { MAX_VALUE 253; }
  DEFAULT_VALUE 11;
}

//-------------------------------------

VARIABLE hardware_revision
{
  LABEL	[hardware_revision];
  HELP	[hardware_revision_help];
  HANDLING READ;
  CLASS DEVICE;
  TYPE UNSIGNED_INTEGER;
  DEFAULT_VALUE 2;
}

//-------------------------------------

VARIABLE device_id
{
  LABEL	[device_identification];
  HELP	[field_device_identification_help];
  HANDLING READ;
  CLASS HART; 
  TYPE UNSIGNED_INTEGER(3);
}

//-------------------------------------

VARIABLE device_type 
{
  LABEL	[device_type];
  HELP	[manufacturers_device_type_help];
  HANDLING READ;
  CLASS HART; 
  TYPE ENUMERATED(1) {
    IF( manufacturer_id == 142 ) {	// Mettler Toledo Device Types
      { 120, "CondInd 7100e/2(X)H" }
    }
    { 252, [unknown] }
  }
}

//-------------------------------------

VARIABLE request_preambles
{
  LABEL	[number_of_request_preambles];
  HELP	[number_of_request_preambles_help];
  HANDLING READ;
  CLASS HART; 
  TYPE UNSIGNED_INTEGER {
    INITIAL_VALUE 5;
    DEFAULT_VALUE 5;
    MIN_VALUE  2;
    MAX_VALUE 20;
  }
}

//-------------------------------------

VARIABLE response_preambles
{
  LABEL	[number_of_response_preambles];
  HELP	[number_of_response_preambles_help];
  HANDLING WRITE;
  CLASS HART;
  TYPE UNSIGNED_INTEGER	{
    INITIAL_VALUE 5;
    DEFAULT_VALUE 5;
  }
}

//-------------------------------------

VARIABLE device_flags
{
  LABEL	[device_flags];
  HELP	[field_device_flags_help];
  HANDLING READ;
  CLASS HART; 
  TYPE BIT_ENUMERATED {
    { 0x01, [Multisens_Dev], [multi_sensor_fld_dev] },
    { 0x02, [EEPROM_Ctrl] },
    { 0x04, [protocol_bridge_device] }
  }
}

//-------------------------------------

VARIABLE physical_signaling_code
{															  
  LABEL	[physical_signalling_code];
  HELP	[physical_signalling_code_help];
  HANDLING READ;
  CLASS DEVICE;
  TYPE ENUMERATED {
    { 0, [bell_202_current] },
    { 1, [bell_202_voltage] },
    { 2, [rs_485] },
    { 3, [rs_232], [rs_232_help] },
    { 6, [special] }
  }
}

//-------------------------------------

VARIABLE final_assembly_number
{
  LABEL	[final_assembly_number];
  HELP	[final_assembly_number_help];
  HANDLING READ & WRITE;
  CLASS DEVICE;
  TYPE UNSIGNED_INTEGER(3) {
    MAX_VALUE 16777215;
  }
}

//-------------------------------------

VARIABLE date
{
  LABEL	[date];
  HELP	[date_help];
  HANDLING READ & WRITE;
  CLASS DEVICE;
  TYPE DATE;
}

//-------------------------------------

VARIABLE primary_damping_value
{
  LABEL	[damping_value];
  HELP	[seconds_damping_value_help]; 
  CLASS CORRECTION;
  TYPE FLOAT {
    DISPLAY_FORMAT	".2f";
  }
  CONSTANT_UNIT	[sec];
  HANDLING READ & WRITE;
}


//-------------------------------------

VARIABLE write_protect
{
  LABEL	[write_protect];
  HELP	[write_protect_mode_help];
  HANDLING READ;
  CLASS DEVICE;
  TYPE ENUMERATED {
    {   0, [not_write_protected] },
    {   1, [write_protected] },
    { 250, [not_used] },
    { 251, [none] },
    { 252, [unknown] },
    { 253, [special] }
  }
}

//-------------------------------------

VARIABLE private_label_distributor
{
  LABEL	[private_label_distributor];
  HELP	[private_label_distributor_help];
  HANDLING READ;
  CLASS DEVICE;
  TYPE ENUMERATED {
    { 142, "Mettler Toledo"}
  }
}

//-------------------------------------
VARIABLE primary_analog_current_value
{   
  LABEL	[analog_value_block_1];
  HELP	[analog_value_help];    
  CLASS	CONTAINED & DYNAMIC;
  HANDLING READ;  
  CONSTANT_UNIT	[mA]; 
  TYPE FLOAT {
    DISPLAY_FORMAT	".3f";
  }
}
//-------------------------------------

VARIABLE dummy_status
{	LABEL		"dummy" ;
	HELP		" " ;
	HANDLING READ ;
	TYPE		BIT_ENUMERATED {
     /* HC275:"1234567890123456" */
		{ 0x01, " ", MISC & IGNORE_IN_HANDHELD } ,
		{ 0x02, " ", MISC & IGNORE_IN_HANDHELD } ,
		{ 0x04, " ", MISC & IGNORE_IN_HANDHELD } ,
		{ 0x08, " ", MISC & IGNORE_IN_HANDHELD } ,
		{ 0x10, " ", MISC & IGNORE_IN_HANDHELD } ,
		{ 0x20, " ", MISC & IGNORE_IN_HANDHELD } ,
		{ 0x40, " ", MISC & IGNORE_IN_HANDHELD } ,
		{ 0x80, " ", MISC & IGNORE_IN_HANDHELD }
	}
}

//-------------------------------------

VARIABLE function_check_status {
	CLASS    DEVICE & DYNAMIC;
	LABEL		"Device Status" "|de|Gertestatus" ;
	HELP		"Device status and mode" "|de|Gertestatus und Zustnde";
	STYLE "MULTILINE 12 3";
	HANDLING READ ;
	TYPE		BIT_ENUMERATED {
     /* HC275:"1234567890123456" */
		{ 0x01, "Configuration" "|de|Konfiguration", MODE & IGNORE_IN_HANDHELD } ,
		{ 0x02, "Calibration" "|de|Kalibrierung", MODE & IGNORE_IN_HANDHELD } ,
		{ 0x04, "Sample was taken" "|de|Produktkalbrierung gestartet", MISC & IGNORE_IN_HANDHELD }
	}
	valid_2212
}

/*------------------------------------------------------------------------------------*/
/*		definition of collection for dynamic variables								  */
/*------------------------------------------------------------------------------------*/

COLLECTION OF VARIABLE pv {
	LABEL           [pv] ;
	HELP            [primary_variable_help] ;
	MEMBERS         {
			 /*             Sensor Correction Information                          			  */
			 DIGITAL_UNITS,         sensor_units,           [units],                        [digital_units_help] ;
			 DIGITAL_VALUE,         sensor_value,           [blank],                        [digital_value_help] ;
			 SENSOR_UNITS,          sensor_units,           [sensor_unit],                  [digital_units_help] ;

			 UPPER_SENSOR_LIMIT,    sensor_upper_limit,     [usl],                          [upper_sensor_limit_help] ;
			 LOWER_SENSOR_LIMIT,    sensor_lower_limit,     [lsl],                          [lower_sensor_limit_help] ;
			 MINIMUM_SPAN,          sensor_minimum_span,    [minimum_span],                 [minimum_span_help] ;
			 
			 /*             Analog Output Information                                       */
			 ANALOG_VALUE,          mA_output_current,      [analog_output_value],          [analog_value_help] ;
			 ALARM_CODE,            analog_alarm_code,      [alarm_select],                 [alarm_code_help] ;
			 
			 /*             Input Information                                               */
			 PERCENT_RANGE,         percent_of_range,       [percent_of_range_help] ;
			 TRANSFER_FUNCTION,     xmtr_transfer_function, [transfer_function_help] ;
			 RANGE_UNITS,           sensor_units,           [range_units_help] ;

			 UPPER_RANGE_VALUE,     output_current_urv,[urv],[upper_range_value_help] ;
			 LOWER_RANGE_VALUE,     output_current_lrv,[lrv],[lower_range_value_help] ;
			 SENSOR_SERIAL_NUMBER,  sensor_serial_number,   [sensor_serial_number],         [sensor_serial_number_help] ;
			 DAMPING_VALUE,         sensor_damping_value,   [damping_value],                [seconds_damping_value_help] ;
			}
}


#define def_config_variables \
        selected_pv_unit, \
        selected_22mA,\
        selected_hold_last_fix,\
        var_fix_value, \
        selected_temp_unit,\
        selected_temp_sensor,\
        selected_lin_log, \
        selected_log_lr, \
        selected_log_ur, \
        output_current_urv, \
        output_current_lrv,  \
        selected_TC_func,\
        var_TC_lin,\
        selected_senso_check
        

#define def_config_variables_e 	\
    selected_pv_unit,			\ 
    selected_temp_unit, 		\
    selected_temp_sensor,		\
    selected_22mA,				\
    selected_hold_last_fix,		\
    var_fix_value, 				\
    selected_lin_log,			\
    selected_log_lr,			\
    selected_log_ur, 			\
    output_current_urv,			\
    output_current_lrv,			\
    selected_TC_func,			\
    var_TC_lin,					\
    selected_senso_check, 		\
    var_cell_factor,           \
    var_zeropoint,              \
    var_sensor_factor_sfc,                    \
    var_fix_value,              \
    var_filter_1,				\
    var_alarmdelay_1,           \
    selected_holdLED,           \
    selected_sensor 
	
/* #define def_config_variables_e_conc 	\
    def_config_variables_e, \
	selected_conc_sol */


MENU upload_variables
{
	LABEL "Upload Variables";
	/* read & write variables 2211pH 
	e2211pH spezifische Variablen gehen nicht da ITEM-liste nicht umschaltbar ist und der Validitystatus der Variablen nicht bercksichtigt wird */
	
		ITEMS {  		polling_address,
    					tag,	   
    					descriptor,																		   
    					message,
    					final_assembly_number,
    					date,
    					response_preambles,
						sensor_value,

				IF (hardware_revision >= e2212_HW_rev){
						def_config_variables_e				
				} 	
				ELSE{
						def_config_variables
				}
   
				IF ( selected_pv_unit_local == 1 )
				{
						selected_conc_sol
				}
   		}

	PRE_WRITE_ACTIONS{
		pre_load
	}
}



MENU download_variables		// Lesen aus Feldgert
{
  LABEL	[menu_load_to_PC];
  ITEMS {
    tag,		//--- Standard-HART-Parameter ---
    descriptor,
    message,
    manufacturer_id,
    universal_revision,
    transmitter_revision,
    software_revision,
    hardware_revision,
    device_id,
    device_type,
    device_flags,
    physical_signaling_code,
    final_assembly_number,
    date,
			//--- Transmitter-Specific Variables ---

	sensor_value,

				IF (hardware_revision >= e2212_HW_rev){
						def_config_variables_e				
				} 	
				ELSE{
						def_config_variables
				}

//-------------------------
				IF ( selected_pv_unit_local == 1 )
				{
						selected_conc_sol
				}		
//-------------------------

  }
	PRE_READ_ACTIONS{
		pre_load	}
}


METHOD pre_load
{
	LABEL "Pre-Read for Up/Download Menu";
	DEFINITION
	{
        send( 0, status );
        iassign ( selection_code_index, transvar_input); 	    
		send_trans(128, 2, status);
		assign_var (selected_pv_unit, selected_pv_unit);	  
	}
}

/*------------------------------------------------------------------------------------*/
/* Hilfsvariablen zum fllen von Lcken, Inhalt wird verworfen						  */
/*------------------------------------------------------------------------------------*/

VARIABLE dummy1
{
  CLASS DEVICE & DIAGNOSTIC & DYNAMIC;
  LABEL	"Dummy1Byte";
  HANDLING READ & WRITE;
  TYPE UNSIGNED_INTEGER(1);
}

VARIABLE dummy4
{
  CLASS DEVICE & DIAGNOSTIC & DYNAMIC;
  LABEL	"Dummy4Byte";
  HANDLING READ & WRITE;
  TYPE UNSIGNED_INTEGER(4);
}


/*------------------------------------------------------------------------------------*/
/*      transmitter-specific commands #128, #129                                      */
/*------------------------------------------------------------------------------------*/

#define send_trans_read( _status, _transvar ) \
				if( e2212_meth ){ \
					iassign( selection_code_index_e, _transvar ); \
					send_trans( 128, 3, _status ); \
				}else{ \
					iassign( selection_code_index, _transvar ); \
					send_trans( 128, 2, _status ); \
				}

#define send_trans_write( _status, _transvar ) \
				if( e2212_meth ){ \
					iassign( selection_code_index_e, _transvar ); \
					send_trans( 129, 3, _status ); \
				}else{ \
					iassign( selection_code_index, _transvar ); \
					send_trans( 129, 2, _status ); \
				}

/*-------------------------------------------*/

REFRESH rel_pv_unit
{
	sensor_units, selected_pv_unit :
	sensor_value, 	var_cond, var_res, var_sample_cal,
	sensor_upper_limit, sensor_lower_limit, sensor_minimum_span,
	output_current_urv ,output_current_lrv, analog_output_fixed1,
	var_cell_factor, var_zeropoint, var_sensor_factor_sfc
}

/*-------------------------------------------*/

REFRESH rel_sv_unit
{
	selected_temp_unit :
	sv_temp_value, var_temp
}

/*-------------------------------------------*/

REFRESH rel_status
{
	function_check_status :
	def_config_variables_e
	
}


/*------------------------------------------------------------------------------------*/
/* Hilfsvariablen um zusammengesetzte Transmitter Variablen zu definieren			  */
/*------------------------------------------------------------------------------------*/

VARIABLE selection_code_index
{
  CLASS USER_INTERFACE;
  LABEL	"Sel. Code Index";
  HELP	"";
  TYPE INDEX selection_codes;
  HANDLING READ & WRITE;
}  


VARIABLE selection_code_index_e
{
  CLASS USER_INTERFACE;
  LABEL	"Sel. Code Index e";
  HELP	"";
  TYPE INDEX selection_codes_e;
  HANDLING READ & WRITE;
} 

ARRAY OF COLLECTION selection_codes
{
  LABEL	"Selection Codes";
  HELP	"";
  ELEMENTS {
    transvar_input, input1_selection_code, 	"";
    transvar_tc, TC_selection_code, 	"";
    transvar_lin_log, output1_function_code, 	"";
    transvar_diag, diag_code, 		"";
    transvar_output, output1_selection_code, 	"";
    transvar_sel_sensor, sensor_selection_code, "";
   }
} 

ARRAY OF COLLECTION selection_codes_e
{
  LABEL	"Selection Codes";
  HELP	"";
  ELEMENTS {
      transvar_conf_4, conf_4_selection_code, "";
               }
} 
/*------------------------------------------------------------------------------------*/

/*------------------------------------------------------------------------------------*/
/*  Transmitter Specific Variable 10                                                  */
/*------------------------------------------------------------------------------------*/
COLLECTION OF VARIABLE input1_selection_code
{
  LABEL "Input Selection Code";
  MEMBERS {
    BYTE1,	selected_pv_unit ;
    BYTE2,	selected_conc_sol ;
    BYTE3,	selected_temp_unit ;
    BYTE4,	selected_temp_sensor ;
  }
}

/*------------------------------------------------------------------------------------*/
/*  Transmitter Specific Variable 11                                                  */
/*------------------------------------------------------------------------------------*/

COLLECTION OF VARIABLE TC_selection_code
{
  LABEL "TC Selection Code";
  MEMBERS {
    BYTE1,	selected_TC_func ;
    BYTE2,	dummy1 ;
    BYTE3,	dummy1 ;
    BYTE4,	dummy1 ;
  }
}

/*------------------------------------------------------------------------------------*/
/*  Transmitter Specific Variable 13                                                  */
/*------------------------------------------------------------------------------------*/

COLLECTION OF VARIABLE output1_function_code
{
  LABEL "Output Function Code";
  MEMBERS {
    BYTE1,	selected_lin_log ;
    BYTE2,	selected_log_lr ;
    BYTE3,	selected_log_ur ;
    BYTE4,	dummy1 ;
  }
}

/*------------------------------------------------------------------------------------*/
/*  Transmitter Specific Variable 16                                                  */
/*------------------------------------------------------------------------------------*/

COLLECTION OF VARIABLE diag_code
{
  LABEL "Diag. Code";
  MEMBERS {
    BYTE1,	selected_senso_check ;
    BYTE2,	dummy1 ;
    BYTE3,	dummy1 ;
    BYTE4,	dummy1 ;
  }
}

/*------------------------------------------------------------------------------------*/
/*  Transmitter Specific Variable 20                                                  */
/*------------------------------------------------------------------------------------*/

COLLECTION OF VARIABLE output1_selection_code
{
  LABEL "Output Selection Code";
  MEMBERS {
    BYTE1,	selected_22mA ;
    BYTE2,	selected_hold_last_fix ;
    BYTE3,	dummy1 ;
    BYTE4,	dummy1 ;
  }
}

/*------------------------------------------------------------------------------------*/
/*  Transmitter Specific Variable 33                                                  */
/*------------------------------------------------------------------------------------*/

COLLECTION OF VARIABLE conf_4_selection_code
{
  LABEL "Conf.4 Sel. Code";
  MEMBERS {
    BYTE1,	selected_holdLED;
    BYTE2,	dummy1 ;
    BYTE3,	dummy1 ;
    BYTE4,	dummy1 ;
  }
}

/*------------------------------------------------------------------------------------*/
/*  Transmitter Specific Variable 34                                                  */
/*------------------------------------------------------------------------------------*/

COLLECTION OF VARIABLE sensor_selection_code
{
  LABEL "Sensorselection";
  MEMBERS {
    BYTE1,	selected_sensor;
    BYTE2,	dummy1 ;
    BYTE3,	dummy1 ;
    BYTE4,	dummy1 ;
  }
}

/*------------------------------------------------------------------------------------*/

VARIABLE sensor_units
{
	CLASS           INPUT;
	LABEL           "PV Unit" ;
	HELP            [digital_units_help] ;
	HANDLING        READ & WRITE ;
/*	TYPE            ENUMERATED { IF (!e2211) {USED_UNITS}ELSE{USED_UNITS_E} }*/
  TYPE ENUMERATED {
    { 37, UNIT_MOHM,   UNIT_MOHM },
    { 56, UNIT_US,     UNIT_US },
	{ 57, UNIT_PERC,   UNIT_PERC},
    { 246, UNIT_SAL,   UNIT_SAL}
  }
}

VARIABLE sensor_value
{
	CLASS           INPUT & DYNAMIC ;
	LABEL           [pv] ;
	HELP            [digital_value_help] ;
	HANDLING        READ ;
	pv_unit_type
}

VARIABLE sensor_upper_limit
{
	CLASS           INPUT & DYNAMIC ;
	LABEL           "PV USL" ;
	HELP            [upper_sensor_limit_help];
	HANDLING        READ;
	pv_unit_type
}

VARIABLE sensor_lower_limit
{
	CLASS           INPUT & DYNAMIC ;
	LABEL           "PV LSL" ;
	HELP            [lower_sensor_limit_help] ;
	HANDLING        READ ;
	pv_unit_type
}

VARIABLE sensor_minimum_span
{
	CLASS           INPUT & DYNAMIC ;
	LABEL           "Min. Span" ;
	HELP            [minimum_span_help] ;
	HANDLING        READ ;
	pv_unit_type
}

VARIABLE sensor_damping_value
{
	CLASS           INPUT;
	LABEL           [pv_damping_value] ;
	HELP            [seconds_damping_value_help] ;
	HANDLING        READ & WRITE ;
	CONSTANT_UNIT   [sec] ;
	TYPE            INTEGER (4) ;
}

VARIABLE analog_alarm_code
{
	CLASS           ANALOG_OUTPUT ;
	LABEL           [alarm_select] ;
	HELP            [alarm_code_help] ;
	HANDLING        READ ;
	TYPE            ENUMERATED
			{
			 ALARM_SELECTION_CODE(0) ,
			 ALARM_SELECTION_CODE(1) ,
			 ALARM_SELECTION_CODE(239) ,
			 ALARM_SELECTION_CODE(250) ,
			 ALARM_SELECTION_CODE(251) ,
			 ALARM_SELECTION_CODE(252) ,
			 ALARM_SELECTION_CODE(253)
			}
}

VARIABLE xmtr_transfer_function
/*
	From Table 9.2 of the Transmitter Specific Document, Rev 5.0.
	Subset of Table III, Transfer Function Codes.
*/
{
	CLASS           CORRECTION;
	LABEL           [transfer_function] ;
	HELP            "You can choose the kind of dependence of the current from the digital value";
	HANDLING        READ & WRITE ;
	TYPE            ENUMERATED
			{
			 TRANSFER_FUNCTION_CODE (0),            /* Linear */
			 TRANSFER_FUNCTION_CODE (1)             /* Square Root */
			}
}

/* VARIABLE input_units */
/*
	From Table 9.1 of the Transmitter Specific Document, Rev 5.0.
	Subset of Table II, Unit Codes.
*/
/* {
	CLASS           INPUT;
	LABEL           "Input Units" ;
	HELP            [range_units_help] ;
	HANDLING        READ & WRITE ;
	TYPE            ENUMERATED{ ALL_UNITS }
    valid_2211
}  */

VARIABLE sensor_serial_number
{
	CLASS           DEVICE;
	LABEL           "Number" ;
	HELP            [sensor_serial_number_help] ;
	HANDLING        READ & WRITE ;
	TYPE            UNSIGNED_INTEGER (3) ;
}

/*	secondary variable for universal command #3		*/
VARIABLE sv_temp_value
{
	CLASS           INPUT & DYNAMIC ;
	LABEL           "SV" ;
	HELP				 "Temperature for conductivity temperature compensation if applied" ;
	HANDLING        READ ;
	sv_unit_type
}

VARIABLE sv_temp_units
{
  LABEL	"Unit";
  HELP	[digital_units_help];
  CLASS CORRECTION & DYNAMIC;
  HANDLING READ & WRITE;
  DEFAULT_VALUE	32;
  TYPE ENUMERATED {
    { 32, [degC],    [degrees_celsius_help] },
    { 33, [degF],    [degrees_fahrenheit_help] }
  }
}

/********************************************************************************************************/
/*      array and index for transmitter-specific commands                                               */
/********************************************************************************************************/

VARIABLE transmitter_variable_index
{
	CLASS           USER_INTERFACE ;
	LABEL           [blank] ;
	TYPE            INDEX transmitter_variable_array ;
}

ARRAY OF VARIABLE transmitter_variable_array
{
	ELEMENTS {											/* Var Nr */
		transvar_cond, 			var_cond ;				/*   00   */
		transvar_conc, 			var_conc ;				/*   01   */
		transvar_temp, 			var_temp ;				/*   02   */
        transvar_sal, 			var_salinity ;			/*   03   */
        transvar_cond_oTC, 	    var_conductance;		/*   04   */
        transvar_curr, 			mA_output_current ;		/*   08   */
		transvar_perc, 			percent_of_range ;		/*   09   */
		transvar_tc_lin, 		var_TC_lin ;			/*   12   */
		transvar_curr_lrv, 		output_current_lrv ;	/*   14   */
		transvar_curr_urv, 		output_current_urv ;	/*   15   */
		transvar_cell, 			var_cell_factor ;		/*   17   */
        transvar_zero,          var_zeropoint ;         /*   18   */
        transvar_sfc,           var_sensor_factor_sfc ; /*   19   */
        transvar_fix_value, 	var_fix_value ;		    /*   21   */
		transvar_sample_cal,	var_sample_cal ;	    /*   30   */
	    transvar_filter_1,		var_filter_1 ;		    /*   31   */
	    transvar_alarmdelay_1,	var_alarmdelay_1 ;		/*   32   */
	}
}

VARIABLE var_cond                                                               /* V0                   */
{
	CLASS           INPUT & DYNAMIC ;
	LABEL           "Cond" "|de|Leitfhigkeit";
	HELP            "Conductivity, temperature compensated if applied" "|de|Leitfhigkeit, mglicherweise temperaturkompensiert";
	HANDLING        READ ;
	cond_unit_type
}       

VARIABLE var_conc                                                               /* V1                   */
{
	CLASS           INPUT & DYNAMIC ;
	LABEL           "Conc" "|de|Konzentration" ;
	HELP            "Concentration of specified solution, temperature compensated" "|de|Konzentration der jeweiligen Lsung, Temperaturkompensierter Messwert";
	HANDLING        READ;
	CONSTANT_UNIT   UNIT_PERC;
	TYPE            FLOAT{ DISPLAY_FORMAT DISPLAY_CONC }
}

VARIABLE var_temp							
{
	CLASS           INPUT & DYNAMIC ;
	LABEL           "Temperature" "|de|Temperatur" ;
	HELP			"Temperature for conductivity or concentration temperature compensation if applied" "|de|aktuelle Metemperatur fr Leitfhigkeit oder Konzentration, mglicherweise temperaturkompensiert";
	HANDLING        READ ;
	sv_unit_type
}

VARIABLE var_salinity                                                           /* V3                   */
{
	CLASS           INPUT & DYNAMIC ;
	LABEL           "Salinity" "|de|Salinitt" ;
	HELP            "Salinity calculated from conductivity and temperature" "|de|Salinitt wird berechnet aus der Leitfhigkeit und der Temperatur" ;
	HANDLING        READ;
	CONSTANT_UNIT   UNIT_SAL;
	TYPE            FLOAT{ DISPLAY_FORMAT DISPLAY_SAL }
}

VARIABLE var_cond_oTC                                                           /* V4                   */
{
	CLASS           INPUT & DYNAMIC ;
	LABEL           "Cond TC" ;
	HELP            "Conductivity without temperature compensation" "|de|Leitfhigkeit ohne Temperaturkompensation";
	HANDLING        READ ;
	cond_unit_type
}       

VARIABLE mA_output_current                                                      /* V8                   */
{
	CLASS           ANALOG_OUTPUT & DYNAMIC ;
	LABEL           "PV AO" ;
	HELP            [analog_value_help] ;
	HANDLING        READ & WRITE ;
	CONSTANT_UNIT   UNIT_MA ;
	TYPE            FLOAT{
		DISPLAY_FORMAT	DISPLAY_CURR	
		EDIT_FORMAT		DISPLAY_CURR 
	}
}

VARIABLE percent_of_range                                                       /* V9                   */
{
	CLASS           ANALOG_OUTPUT & DYNAMIC ;
	LABEL           "PV %" ;
	HELP            [percent_of_range_help] ;
	HANDLING        READ ;
	CONSTANT_UNIT   UNIT_PERC;
	TYPE            FLOAT{ DISPLAY_FORMAT DISPLAY_PERC }
}

VARIABLE var_TC_lin                                                 /* 1/4/2/4 V12 E        */
{
	CLASS           CORRECTION;
	LABEL           "Linear TC" "|de|Linear TC";
	HELP            "Linear temperature coefficent used to compute the temperature compensated conductivity if applied" "|de|Lineare Temperaturkompensation in %/K (nur bei LIN oder NLF)";
	HANDLING        READ & WRITE ;
	CONSTANT_UNIT   UNIT_TC_LIN;
	TYPE            FLOAT{
			 DISPLAY_FORMAT  "5.2f";
			 EDIT_FORMAT     "5.2f";
			 MIN_VALUE       0.00 ;
			 MAX_VALUE       19.99 ;
	}
}



VARIABLE output_current_urv                                         /* 1/4/3/2/2 V15        */                                                      /* V15                  */
{
	CLASS           ANALOG_OUTPUT;
	LABEL           "LIN: upper range" "|de|LIN: Stromanfang"; 
	HELP            [upper_range_value_help] ;
	HANDLING        READ & WRITE ;
	output_unit_type

    VALIDITY IF (selected_lin_log == 0){  /* if Lin selected */
        TRUE;
    }ELSE{
       FALSE;
   } 
}

VARIABLE output_current_lrv                                         /* 1/4/3/2/1 V14        */
{
	CLASS           ANALOG_OUTPUT;
	LABEL           "LIN: lower range" "|de|LIN: Stromende";
	HELP            [lower_range_value_help] ;
	HANDLING        READ & WRITE ;
	output_unit_type

    VALIDITY IF (selected_lin_log == 0){  /* if Lin selected */
        TRUE;
    }ELSE{
       FALSE;
   } 
}

VARIABLE selected_hold_last_fix                                                                /* V18.1 */
{
	CLASS           ANALOG_OUTPUT;
	LABEL           "HOLD Last/Fix" ;
	HELP            "The output current behavior in the HOLD mode can be specified. Last- the output current is frozen at its last value, Fix- a constant value from 3.8mA to 22mA" ;
	HANDLING        READ & WRITE ;
	selected_hold_last_fix_enum
}


/********************************************************************************************************/

VARIABLE var_fix_value							/* V21		*/
{
	CLASS           ANALOG_OUTPUT;
	LABEL           "HOLD Fix value" "|de|HOLD-Festwert";
	HELP			"Specifies fixed output current in HOLD mode" "|de|Festwert fr Ausgangsstrom im HOLD-Zustand";
	HANDLING        READ & WRITE ;
	CONSTANT_UNIT   UNIT_MA;
	DEFAULT_VALUE	21;
	TYPE            FLOAT{	
		DISPLAY_FORMAT       DISPLAY_CURR
		EDIT_FORMAT          DISPLAY_CURR
		MIN_VALUE            3.8;
		MAX_VALUE            22.0;
	}
}





VARIABLE selected_pv_unit                                                                      /* V10.0 */
{
	CLASS 			 INPUT;
	LABEL           "PV Range/Unit" "|de|PV Bereich/Einheit" ;
	HELP            "Select display format" "|de|Whlen Sie das Anzeigeformat";
	HANDLING        READ & WRITE ;
	selected_pv_enum
	
	POST_EDIT_ACTIONS{
		 pre_test
		 method_set_lin
	}

	POST_WRITE_ACTIONS{
		pre_test
	}
}


METHOD pre_test
{
	LABEL "Pre Test Method";
	DEFINITION
	{
		if ((selected_pv_unit ==  3) || (selected_pv_unit ==  4) ){ /* bei % und SAL kein LOG */
	   		assign_int( selected_pv_unit_local, 1 ); 
		}else{
			assign_int( selected_pv_unit_local, 0 );		
		}
	}
}


VARIABLE selected_pv_unit_local                                                                /* V10.0 */
{
	CLASS 			LOCAL;
	HANDLING        READ & WRITE;
	TYPE			INTEGER;

}


VARIABLE selected_temp_unit                                     /* V10.2                */
{
	CLASS 			 INPUT;
	LABEL           "Temp Unit" "|de|Temperatureinheit";
	HELP				 "Select the temperature unit" "|de|Whlen Sie die Temperatureinheit" ;
	HANDLING        READ & WRITE ;
	selected_temp_unit_enum
}

VARIABLE selected_temp_sensor                                           /* V10.3                */
{
	CLASS 			 INPUT;
	LABEL           "Temp Probe" "|de|Temperaturfhler";
	HELP				 "Select the temperature source" "|de|Whlen Sie den Temperaturfhler";
	HANDLING        READ & WRITE ;
	selected_temp_sensor_enum

	VALIDITY IF (selected_sensor == 4){
		TRUE;
	}ELSE{
		FALSE;
	}

}

/*      variable declarations for TC selection code in 9.5                              */

VARIABLE selected_TC_func                                       /* V11.0                */
{
	CLASS           CORRECTION ;
	LABEL           "Temp Compensation" "|de|Temperaturkompensation";
	HELP            "Select temp compensation" "|de|Whlen Sie die Temperaturkompensation" ;
	HANDLING        READ & WRITE ;
	selected_tc_enum
}

/********************************************************************************************************/
/*      variable declarations for Meas/Output relation codes in 9.6                                     */
/********************************************************************************************************/

VARIABLE selected_lin_log                                                                      /* V13.0 */
{
	CLASS           ANALOG_OUTPUT;
	LABEL           "Characteristic" "|de|Kennlinie";
	HELP            "Select current characteristic  (lin or log)" "|de| Whlen SIe die aktuelle Kennlinie";
	HANDLING        READ & WRITE ;
	
    TYPE ENUMERATED{ 
        IF ((selected_pv_unit==3) || (selected_pv_unit==4)){
            { 0, "Lin"}
        }ELSE{
           { 0, "Lin"},
           { 1, "Log"}
        }    
	}
	POST_READ_ACTIONS{
		method_set_lin
	}
	VALIDITY IF (selected_pv_unit == 11){
		FALSE;
	}ELSE{
		TRUE;
	}

}

METHOD method_set_lin
{
  CLASS	INPUT;
  DEFINITION
  {
   	if  ((selected_pv_unit==3) || (selected_pv_unit==4)){
		   assign_int( selected_lin_log, 0);
	}  
  } 
}


VARIABLE selected_log_lr                                        /* V13.1                */
{
	CLASS           ANALOG_OUTPUT;
	LABEL           "log: lower range" "|de|LOG: Stromende";
	HELP            "Select lower current range for log" "|de|Whlen Sie den Stromende fr die Kennlinie LOG";
	HANDLING        READ & WRITE ;

    TYPE ENUMERATED{ 			          
        IF (!e2212){                      
        	 { 0, "0.1 mS"},              
		     { 1, "1.000 mS"},            
			 { 2, "10.00 mS"},            
			 { 3, "100.0 mS"},            
			 { 4, "1000 mS"}              
        }ELSE{                            
             { 0, "0.1 mS/0.001 Sm"},     
			 { 1, "1.0 mS/0,01 Sm"},      
			 { 2, "10.0 mS/0,1 Sm"},      
			 { 3, "100.0 mS/1,0 Sm"},     
			 { 4, "1000 mS/10,0 Sm"},      
             { 5, "0.01 mS/100.0 Sm"},    
             { 6, "0.001 mS"}             
        }                                 
	}
        VALIDITY IF (selected_lin_log == 1){  /* if Log selected */
        TRUE;
    }ELSE{
       FALSE;
   } 
 
}

VARIABLE selected_log_ur                                        /* V13.2                */
{
	CLASS           ANALOG_OUTPUT;
	LABEL           "log: upper range" "|de|LOG: Stromanfang";
	HELP            "Select upper current range for log" "|de|Whlen Sie ds Stromanfang fr die Kennlinie LOG";
	HANDLING        READ & WRITE ;
    TYPE ENUMERATED{ 			          
        IF (!e2212){                      
        	 { 0, "0.1 mS"},              
		     { 1, "1.000 mS"},            
			 { 2, "10.00 mS"},            
			 { 3, "100.0 mS"},            
			 { 4, "1000 mS"}              
        }ELSE{                            
             { 0, "0.1 mS/0.001 Sm"},     
			 { 1, "1.0 mS/0,01 Sm"},      
			 { 2, "10.0 mS/0,1 Sm"},      
			 { 3, "100.0 mS/1,0 Sm"},     
			 { 4, "1000 mS/10,0 Sm"},      
             { 5, "0.01 mS/100.0 Sm"},    
             { 6, "0.001 mS"}             
        }                                 
	}
        VALIDITY IF (selected_lin_log == 1){  /* if Log selected */
        TRUE;
    }ELSE{
       FALSE;
   } 
}

/*      variable declaration for Sensocheck  (9.7)                      */

VARIABLE selected_senso_check                                      /* V16.0                */                                                                     /* V0                 */
{
	CLASS           CORRECTION;
	LABEL           "Sensocheck" ;
	HELP            "Sensocheck continuously monitors the sensor" "|de|Sensocheck berwacht den Sensor" ;
	HANDLING        READ & WRITE;
	selected_off_on_enum
}

VARIABLE var_cell_factor                                        /* V17                */
{
	CLASS           INPUT & DYNAMIC;
	LABEL           "Cell Factor" "|de|Zellfaktor";
	HELP            "Cell factor according to data sheet or calibration" "|de|nomineller Zellfaktor (Sensorspezifische Gre)";
	HANDLING        READ & WRITE ;
	CONSTANT_UNIT   " " ;
	TYPE            FLOAT{
			 DISPLAY_FORMAT         "6.3f";
			 EDIT_FORMAT            "6.3f";
			 MIN_VALUE              0.100 ;
			 MAX_VALUE              19.999 ;
             DEFAULT_VALUE          2.15;
	}
    VALIDITY IF (selected_sensor == 4){
        TRUE;
    }ELSE{
        FALSE;
    }
}

VARIABLE var_zero_point                                        /* V18                */
{
	CLASS           INPUT & DYNAMIC;
	LABEL           "Zero Point" "|de|Nullpunkt";
	HELP            "The displayed value is the Zero Point divided by Cell Factor according to calibration" ;
	HANDLING        READ & WRITE ;
	CONSTANT_UNIT   UNIT_US ;
	TYPE            FLOAT{
			 DISPLAY_FORMAT         "5.0f";
			 EDIT_FORMAT            "5.0f";
			 MIN_VALUE              -500.0 ;
			 MAX_VALUE               500.0 ;
	}
}

VARIABLE var_sensor_factor_sfc                                        /* V19                */
{
	CLASS           INPUT & DYNAMIC;
	LABEL           "Sensor Factor SFC" "|de|bertragungsfaktor" ;
	HELP            "Sensor factor SFC according to data sheet of sensor or calibration" "|de|nomineller bertragungsfaktor (Sensorspezifische Gre)";
	HANDLING        READ & WRITE ;
	CONSTANT_UNIT   " " ;
	TYPE            FLOAT{
			 DISPLAY_FORMAT         "5.2f";
			 EDIT_FORMAT            "5.2f";
			 MIN_VALUE              1.00 ;
			 MAX_VALUE              199.99;
             DEFAULT_VALUE          120.0;
	}
    VALIDITY IF (selected_sensor == 4){
        TRUE;
    }ELSE{
        FALSE;
    }
}

/*      variable declarations for alarm selection codes (9.8)           */

VARIABLE selected_22mA                                       /* V20.0                         */                                                                 /* V0                   */
{
	CLASS           ANALOG_OUTPUT;
	LABEL           "22mA on Error" "|de|22mA bei Fehler" ;
	HELP            "Switch 22mA signal for error message on or off" "|de|Schalten Sie die 22mA Fehlermeldung an oder aus" ;
	HANDLING        READ & WRITE ;
	selected_off_on_enum
}


VARIABLE selected_conc_sol
{
    LABEL "Conc Solution" "|de|Konzentrationslsung";
    HELP  "Select the Solution, when measure unit Conc is selected" "|de|Whlen sie die Konzentrationslsung, wenn als Meeinheit Konzentration gewhlt ist";
    CLASS ANALOG_OUTPUT;
    HANDLING READ & WRITE;
    selected_conc_sol_enum
    
}


VARIABLE transmitter_variable_unit_code                                                          /* V0                  */
{
	CLASS           LOCAL ;
	LABEL           "" ;
	HANDLING        READ ;
	TYPE            INTEGER (1) ;
}



#define var_filter_1_label		"Output Filter" "|de|Ausgangsfilter"
#define var_alarmdelay_1_label	"Alarm Delay" "|de|Alarmzeitverzgerung"
#define meth_sel_alarmLED_label  "Alarm LED Hold" 

#define var_filter_1_help		"Filtertime of output current" "|de|Filterzeit des Ausgangsstromes"
#define var_alarmdelay_1_help	"Alarm delay time of alarm signal" "|de|Alarmzeitverzgerung fr das Alarm Signal"
#define meth_sel_alarmLED_help	"LED state in HOLD Mode: if setting ON - Alarm on and Hold flashes- else setting OFF - Alarm flashes and Hold on -" "|de|LED im Hold Zustand: Parametrierung ON - Alarm an und HOLD blinkt - Parametrierung OFF - Alarm blinkt HOLD an -"



VARIABLE var_sample_cal							/* V30		*/
{
	CLASS           x2212( CORRECTION;, LOCAL; )
	LABEL           "Sample" ;
	HELP			"Calibration with Sampling to determine the electrode zero point" ;
	HANDLING        READ & WRITE ;
    pv_unit_type
    valid_2212
}

VARIABLE var_filter_1							/* V31		*/
{
	CLASS           x2212( ANALOG_OUTPUT;, LOCAL; )
	LABEL           var_filter_1_label;
	HELP			var_filter_1_help;
	HANDLING        READ & WRITE ;
	CONSTANT_UNIT   UNIT_SEC
	TYPE            FLOAT{	
		DISPLAY_FORMAT         DISPLAY_SEC
		EDIT_FORMAT            DISPLAY_SEC
		MIN_VALUE              0.0;
		MAX_VALUE              120.0;
	}
	valid_2212
}

VARIABLE var_alarmdelay_1							/* V32		*/
{
	CLASS           x2212( ANALOG_OUTPUT;, LOCAL; )
	LABEL           var_alarmdelay_1_label;
	HELP			var_alarmdelay_1_help;
	HANDLING        READ & WRITE ;
	CONSTANT_UNIT   UNIT_SEC
    TYPE            FLOAT{	
		DISPLAY_FORMAT         DISPLAY_SEC
		EDIT_FORMAT            DISPLAY_SEC
		MIN_VALUE              0.0;
		MAX_VALUE              600.0;
	}
	valid_2212
}

VARIABLE selected_holdLED						  	/* V33.0	*/
{
	CLASS           x2212( DEVICE;, LOCAL; )
	LABEL           meth_sel_alarmLED_label;
	HELP			meth_sel_alarmLED_help;
	HANDLING        READ & WRITE ;
	selected_off_on_enum
	valid_2212
}

VARIABLE selected_sensor
{
    CLASS x2212( DEVICE;, LOCAL; )
    LABEL "Selected Sensor " "|de|Sensor"; 
    HELP  "";
    HANDLING READ & WRITE;
    selected_sensor_enum
    valid_2212
}




//=============================================================================
//  COMMANDS
//=============================================================================

COMMAND read_unique_identifier
{
  NUMBER 0;
  OPERATION READ;
  TRANSACTION {
    REQUEST { }
    REPLY {
      response_code,
      device_status,
      254,
      manufacturer_id,
      device_type,
      request_preambles,
      universal_revision,
      transmitter_revision,
      software_revision,
      hardware_revision <0xf8>,
      physical_signaling_code <0x07>,
      device_flags,
      device_id
    }
  }
  RESPONSE_CODES {
    0, SUCCESS, [no_command_specific_errors];
  }
}

//-------------------------------------

COMMAND read_primary_variable
{
  NUMBER 1;
  OPERATION READ;
  TRANSACTION {
    REQUEST { }
    REPLY {
      response_code,
      device_status,
      sensor_units,
      sensor_value //sensor_value
    }
  }
  RESPONSE_CODES {
    0, SUCCESS, [no_command_specific_errors];
  }
}

//-------------------------------------

COMMAND read_pv_current_and_percent_range
{
  NUMBER 2;
  OPERATION READ;
  TRANSACTION {
    REQUEST { }
    REPLY {
      response_code,
      device_status,
      mA_output_current,
      percent_of_range
    }
  }
  RESPONSE_CODES {
    0, SUCCESS, [no_command_specific_errors];
  }
}

//-------------------------------------

COMMAND read_dynamic_variables_and_pv_current
{
  NUMBER 3;
  OPERATION READ;
  TRANSACTION {
    REQUEST { }
    REPLY {
      response_code,
      device_status,
      mA_output_current,
      sensor_units,
      sensor_value, 
      sv_temp_units,
      sv_temp_value
    }
  }
  RESPONSE_CODES {
    0, SUCCESS, [no_command_specific_errors];
  }
}

//-------------------------------------

COMMAND write_polling_address
{
  NUMBER 6;
  OPERATION WRITE;
  TRANSACTION {
    REQUEST {
      polling_address
    }
    REPLY {
      response_code,
      device_status,
      polling_address
    }
  }
  RESPONSE_CODES {
     0,	SUCCESS, [no_command_specific_errors];
     2,	DATA_ENTRY_ERROR, [invalid_selection];
     5,	MISC_ERROR, [too_few_data_bytes_recieved];
    32, DATA_ENTRY_ERROR, [busy];
  }
}

//-------------------------------------

COMMAND read_unique_identifier_with_tag
{
  NUMBER 11;
  OPERATION COMMAND;
  TRANSACTION {
    REQUEST {
      tag
    }
    REPLY {
      response_code,
      device_status,
      254,
      manufacturer_id,
      device_type,
      request_preambles,
      universal_revision,
      transmitter_revision,
      software_revision,
      hardware_revision <0xf8>,
      physical_signaling_code <0x07>,
      device_flags,
      device_id 
    }
  }
  RESPONSE_CODES {
    0, SUCCESS, [no_command_specific_errors];
  }
}

//-------------------------------------

COMMAND read_message
{
  NUMBER 12;
  OPERATION READ;
  TRANSACTION {
    REQUEST { }
    REPLY {
      response_code,
      device_status,
      message
    }
  }
  RESPONSE_CODES {
    0, SUCCESS,	[no_command_specific_errors];
  }
}

//-------------------------------------

COMMAND read_tag_descriptor_date
{
  NUMBER 13;
  OPERATION READ;
  TRANSACTION {
    REQUEST { }
    REPLY {
      response_code,
      device_status,
      tag,
      descriptor,
      date
    }
  }
  RESPONSE_CODES {
    0, SUCCESS, [no_command_specific_errors];
  }
}

//-------------------------------------

COMMAND read_pv_sensor_info
{
  NUMBER 14;
  OPERATION READ;
  TRANSACTION {
    REQUEST { }
    REPLY {
      response_code,
      device_status,
      sensor_serial_number,
      sensor_units,
      sensor_upper_limit,
      sensor_lower_limit,
      sensor_minimum_span
    }
  }
  RESPONSE_CODES {
    0, SUCCESS, [no_command_specific_errors];
  }
}

//-------------------------------------

COMMAND read_pv_output_info
{
  NUMBER 15;
  OPERATION READ;
  TRANSACTION {
    REQUEST { }
    REPLY {
      response_code,
      device_status,
      analog_alarm_code,
      xmtr_transfer_function,
      sensor_units,
      output_current_urv,
      output_current_lrv,
      primary_damping_value,
      write_protect,
      private_label_distributor
    }
  }
  RESPONSE_CODES {
    0, SUCCESS, [no_command_specific_errors];
  }
}

//-------------------------------------

COMMAND read_final_assembly_number
{
  NUMBER 16;
  OPERATION READ;
  TRANSACTION {
    REQUEST { }
    REPLY {
      response_code,
      device_status,
      final_assembly_number
    }
  }
  RESPONSE_CODES {
    0, SUCCESS, [no_command_specific_errors];
  }
}

//-------------------------------------

COMMAND write_message
{
  NUMBER 17;
  OPERATION WRITE;
  TRANSACTION {
    REQUEST {
      message
    }
    REPLY {
      response_code,
      device_status,
      message
    }
  }
  RESPONSE_CODES {
     0,	SUCCESS,    [no_command_specific_errors];
     5,	MISC_ERROR, [too_few_data_bytes_recieved];
  }
}

//-------------------------------------

COMMAND write_tag_descriptor_date
{
  NUMBER 18;
  OPERATION WRITE;
  TRANSACTION {
    REQUEST {
      tag,
      descriptor,
      date
    }
    REPLY {
      response_code,
      device_status,
      tag,
      descriptor,
      date
    }
  }
  RESPONSE_CODES {
    0, SUCCESS, [no_command_specific_errors];
    5, MISC_ERROR, [too_few_data_bytes_recieved];
  }
}

//-------------------------------------

COMMAND write_final_assembly_number
{
  NUMBER 19;
  OPERATION WRITE;
  TRANSACTION {
    REQUEST {
      final_assembly_number
    }
    REPLY {
      response_code,
      device_status,
      final_assembly_number
    }
  }
  RESPONSE_CODES {
    0, SUCCESS, [no_command_specific_errors];
    5, MISC_ERROR, [too_few_data_bytes_recieved];
  }
}

//-------------------------------------

COMMAND write_pv_range_values
{
  NUMBER 35;
  OPERATION WRITE;
  TRANSACTION {
    REQUEST {
      sensor_units,
      output_current_urv,
      output_current_lrv
    }
    REPLY {
      response_code,
      device_status,
      sensor_units,
      output_current_urv,
      output_current_lrv
    }
  }
  RESPONSE_CODES {
     0, SUCCESS, [no_command_specific_errors];
     2, DATA_ENTRY_ERROR, [invalid_selection];
     5, MISC_ERROR, [too_few_data_bytes_recieved];
     9, DATA_ENTRY_ERROR, [lower_range_value_too_high];
    10, DATA_ENTRY_ERROR, [lower_range_value_too_low];
    11, DATA_ENTRY_ERROR, [upper_range_value_too_high];
    12, DATA_ENTRY_ERROR, [upper_range_value_too_low];
    13, DATA_ENTRY_ERROR, [URV_and_LRV_out_of_limits];
    14, DATA_ENTRY_WARNING, [span_too_small];
    32, DATA_ENTRY_ERROR, [busy];
  }
}

//-------------------------------------

COMMAND set_pv_upper_range_value
{
  NUMBER 36;
  OPERATION COMMAND;
  TRANSACTION {
    REQUEST { }
    REPLY {
      response_code,
      device_status
    }
  }
  RESPONSE_CODES {
     0, SUCCESS, [no_command_specific_errors];
    32, DATA_ENTRY_ERROR, [busy];
  }
}

//-------------------------------------

COMMAND set_pv_lower_range_value
{
  NUMBER 37;
  OPERATION COMMAND;
  TRANSACTION {
    REQUEST { }
    REPLY {
      response_code,
      device_status
    }
  }
  RESPONSE_CODES {
     0, SUCCESS, [no_command_specific_errors];
    32, DATA_ENTRY_ERROR, [busy];
  }
}

//-------------------------------------

COMMAND reset_configuration_change_flag
{
  NUMBER 38;
  OPERATION COMMAND;
  TRANSACTION {
    REQUEST { }
    REPLY {
      response_code,
      device_status
    }
  }
  RESPONSE_CODES {
    0, SUCCESS, [no_command_specific_errors];
  }
}

//-------------------------------------

COMMAND enter_exit_fixed_pv_current_mode
{
  NUMBER 40;
  OPERATION COMMAND;
  TRANSACTION {
    REQUEST {
      primary_analog_current_value
    }
    REPLY {
      response_code,
      device_status,
      primary_analog_current_value
    }
  }
  RESPONSE_CODES {
    0, SUCCESS, [no_command_specific_errors];
    3, DATA_ENTRY_ERROR, [passed_parameter_too_large];
    4, DATA_ENTRY_ERROR, [passed_parameter_too_small];
    5, MISC_ERROR, [too_few_data_bytes_recieved];
  }
}

//-------------------------------------

COMMAND perform_transmitter_self_test
{
  NUMBER 41;
  OPERATION COMMAND;
  TRANSACTION {
    REQUEST { }
    REPLY {
      response_code,
      device_status
    }
  }
  RESPONSE_CODES {
    0, SUCCESS, [no_command_specific_errors];
  }
}

//-------------------------------------

COMMAND perform_master_reset
{
  NUMBER 42;
  OPERATION COMMAND;
  TRANSACTION {
    REQUEST { }
    REPLY {
      response_code,
      device_status
    }
  }
  RESPONSE_CODES {
     0, SUCCESS, [no_command_specific_errors];
    32, DATA_ENTRY_ERROR, [busy];
  }
}

//-------------------------------------

COMMAND read_additional_transmitter_status
{
  NUMBER 48;
  OPERATION READ;
  TRANSACTION {
    REQUEST { }
    REPLY {
      response_code,
      device_status,
  	  xmtr_specific_status_0 ,		/*  0  */
	  dummy_status ,				/*  1  */
	  xmtr_specific_status_2 ,		/*  2  */		  	
	  dummy_status ,				/*  3 undefined */
	  dummy_status ,				/*  4 undefined */
	  dummy_status ,     			/*  5 undefined */
	  dummy_status ,				/*  6  */
	  dummy_status ,				/*  7  */
	  analog_output_saturated1 ,  	/*  8  */
	  dummy_status ,			  	/*  9 undefined */
	  dummy_status ,			  	/* 10 undefined */
	  analog_output_fixed1,			/* 11  */
	  dummy_status ,				/* 12 undefined */
	  dummy_status ,				/* 13 undefined */
	  dummy_status ,				/* 14 undefined */
	  dummy_status ,				/* 15 undefined */
	  dummy_status ,				/* 16 undefined */
	  dummy_status ,				/* 17 undefined */
	  dummy_status ,				/* 18 undefined */
	  dummy_status ,				/* 19 undefined */
	  dummy_status ,				/* 20 undefined */
	  dummy_status ,				/* 21 undefined */
	  dummy_status ,				/* 22 undefined */
	  dummy_status ,				/* 23 undefined */
	  function_check_status	}		/* 24  */    
  }
  RESPONSE_CODES {
    0, SUCCESS, [no_command_specific_errors];
  }
}

//-------------------------------------

//COMMAND read_transmitter_variable_assignments
/*{
  	NUMBER 50;		// Command #50 muss vorhanden sein!
  	OPERATION READ;
  	TRANSACTION 
  	{
    	REQUEST 
    	{
    	}
    	REPLY 
    	{
			response_code, device_status   		}
  	}
	RESPONSE_CODES {
     0,	SUCCESS, [no_command_specific_errors];
     6,	MISC_ERROR, [xmtr_specific_command_error];
    16,	MODE_ERROR, [access_restricted];
  	}
} */


//-------------------------------------

COMMAND read_transmitter_variable_information
{
  NUMBER 54;
  OPERATION READ;
  TRANSACTION {
    REQUEST {
      transmitter_variable_index( INFO, INDEX )
    }
    REPLY {
      response_code,
      device_status,
      transmitter_variable_index,
      transmitter_variables[transmitter_variable_index].SENSOR_SERIAL_NUMBER,
      transmitter_variables[transmitter_variable_index].SENSOR_UNITS,
      transmitter_variables[transmitter_variable_index].UPPER_SENSOR_LIMIT,
      transmitter_variables[transmitter_variable_index].LOWER_SENSOR_LIMIT,
      transmitter_variables[transmitter_variable_index].DAMPING_VALUE,
      transmitter_variables[transmitter_variable_index].MINIMUM_SPAN
    }
  }
  RESPONSE_CODES {
    0, SUCCESS, [no_command_specific_errors];
    2, MISC_ERROR, [invalid_selection];
    5, MISC_ERROR, [too_few_data_bytes_recieved];
  }
}

//-------------------------------------

COMMAND write_number_of_response_preambles
{
  NUMBER 59;
  OPERATION WRITE;
  TRANSACTION {
    REQUEST {
      response_preambles
    }
    REPLY {
      response_code,
      device_status,
      response_preambles
    }
  }
  RESPONSE_CODES {
    0, SUCCESS, [no_command_specific_errors];
    3, DATA_ENTRY_ERROR, [passed_parameter_too_large];
    4, DATA_ENTRY_ERROR, [passed_parameter_too_small];
    5, MISC_ERROR, [too_few_data_bytes_recieved];
  }
}

//-----------------------------------------------------------------------------

COMMAND read_float_variable
{
  NUMBER 128;
  OPERATION READ;
  TRANSACTION {
    REQUEST {
      transmitter_variable_index (INFO, INDEX)
    }
    REPLY {
      response_code,
      device_status,
	  transmitter_variable_index,
	  transmitter_variable_unit_code,
	  transmitter_variable_array [transmitter_variable_index]
 }
  }
  RESPONSE_CODES {
    0, SUCCESS, [no_command_specific_errors];
    2, DATA_ENTRY_ERROR, [invalid_selection];
    5, MISC_ERROR, [too_few_data_bytes_recieved];
  }
}

//-----------------------------------------------------------------------------

COMMAND read_selections
{
  NUMBER 128;
  OPERATION READ;
  TRANSACTION 1 {
		REQUEST { transmitter_variable_index (INFO,INDEX) }
	 	REPLY {	
	 		response_code,	device_status,
			transmitter_variable_index,
			transmitter_variable_unit_code ,
			transmitter_variable_array [transmitter_variable_index]
		}
	}
	TRANSACTION 2 {
		REQUEST { selection_code_index (INFO,INDEX) }
		REPLY {
			response_code,	device_status,
			selection_code_index,
			UNITS_CODE_NON,
      	selection_codes[selection_code_index].BYTE1,
      	selection_codes[selection_code_index].BYTE2,
      	selection_codes[selection_code_index].BYTE3,
      	selection_codes[selection_code_index].BYTE4
		}
	}
	TRANSACTION 3 {
		REQUEST { selection_code_index_e (INFO,INDEX) }
		REPLY {
			response_code,	device_status,
			selection_code_index_e,
			UNITS_CODE_NON,
      	selection_codes_e[selection_code_index_e].BYTE1,
      	selection_codes_e[selection_code_index_e].BYTE2,
      	selection_codes_e[selection_code_index_e].BYTE3,
      	selection_codes_e[selection_code_index_e].BYTE4
		}
      }

  RESPONSE_CODES {
    0, SUCCESS, [no_command_specific_errors];
    2, DATA_ENTRY_ERROR, [invalid_selection];
    5, MISC_ERROR, [too_few_data_bytes_recieved];
  }
}

//-------------------------------------

COMMAND write_float_variable
{
  NUMBER 129 ;
  OPERATION WRITE ;
  TRANSACTION {
    REQUEST {
			transmitter_variable_index (INFO,INDEX) ,
			transmitter_variable_unit_code ,
			transmitter_variable_array [transmitter_variable_index]

    }
    REPLY {
			response_code,	device_status,
			transmitter_variable_index ,
			transmitter_variable_unit_code ,
			transmitter_variable_array [transmitter_variable_index]    }
  }
  RESPONSE_CODES {
     0, SUCCESS, [no_command_specific_errors] ;
     2, DATA_ENTRY_ERROR, [invalid_selection] ;
     3, DATA_ENTRY_ERROR, [passed_parameter_too_large] ;
     4, DATA_ENTRY_ERROR, [passed_parameter_too_small] ;
     5, MISC_ERROR, [too_few_data_bytes_recieved] ;
     7, MODE_ERROR, [in_write_protect_mode] ;
    12, DATA_ENTRY_ERROR, "Invalid unit code" ;
    32, DATA_ENTRY_ERROR, "Busy" ;
  }
}

//-------------------------------------

COMMAND write_selections
{
  NUMBER 129 ;
  OPERATION WRITE ;
TRANSACTION 1 {
		REQUEST {
			transmitter_variable_index (INFO,INDEX) ,
			transmitter_variable_unit_code ,
			transmitter_variable_array [transmitter_variable_index]
		}
		REPLY {
			response_code,	device_status,
			transmitter_variable_index ,
			transmitter_variable_unit_code ,
			transmitter_variable_array [transmitter_variable_index]
		}
	}
	TRANSACTION 2 {
		REQUEST {
			selection_code_index (INFO,INDEX),
			UNITS_CODE_NON,
      	selection_codes[selection_code_index].BYTE1,
      	selection_codes[selection_code_index].BYTE2,
      	selection_codes[selection_code_index].BYTE3,
      	selection_codes[selection_code_index].BYTE4
		}
		REPLY {
			response_code,	device_status,
			selection_code_index,
			UNITS_CODE_NON,
      	selection_codes[selection_code_index].BYTE1,
      	selection_codes[selection_code_index].BYTE2,
      	selection_codes[selection_code_index].BYTE3,
      	selection_codes[selection_code_index].BYTE4
		}
	}
	TRANSACTION 3 {
		REQUEST {
			selection_code_index_e (INFO,INDEX),
			UNITS_CODE_NON,
      	selection_codes_e[selection_code_index_e].BYTE1,
      	selection_codes_e[selection_code_index_e].BYTE2,
      	selection_codes_e[selection_code_index_e].BYTE3,
      	selection_codes_e[selection_code_index_e].BYTE4
		}
		REPLY {
			response_code,	device_status,
			selection_code_index_e,
			UNITS_CODE_NON,
      	selection_codes_e[selection_code_index_e].BYTE1,
      	selection_codes_e[selection_code_index_e].BYTE2,
      	selection_codes_e[selection_code_index_e].BYTE3,
      	selection_codes_e[selection_code_index_e].BYTE4
		}
	}
  RESPONSE_CODES {
     0, SUCCESS, [no_command_specific_errors] ;
     2, DATA_ENTRY_ERROR, [invalid_selection] ;
     3, DATA_ENTRY_ERROR, [passed_parameter_too_large] ;
     4, DATA_ENTRY_ERROR, [passed_parameter_too_small] ;
     5, MISC_ERROR, [too_few_data_bytes_recieved] ;
     7, MODE_ERROR, [in_write_protect_mode] ;
    12, DATA_ENTRY_ERROR, "Invalid unit code" ;
    32, DATA_ENTRY_ERROR, "Busy" ;
  }
}


/*------------------------------------------------------------------------------------*/
/*      transmitter-specific commands #128, #129                                      */
/*------------------------------------------------------------------------------------*/

#define send_trans_read( _status, _transvar ) \
				if( e2212_meth ){ \
					iassign( selection_code_index_e, _transvar ); \
					send_trans( 128, 3, _status ); \
				}else{ \
					iassign( selection_code_index, _transvar ); \
					send_trans( 128, 2, _status ); \
				}

#define send_trans_write( _status, _transvar ) \
				if( e2212_meth ){ \
					iassign( selection_code_index_e, _transvar ); \
					send_trans( 129, 3, _status ); \
				}else{ \
					iassign( selection_code_index, _transvar ); \
					send_trans( 129, 2, _status ); \
				}

/*------------------------------------------------------------------------------------*/
/*      transmitter-specific commands #131                                			  */
/*------------------------------------------------------------------------------------*/

COMMAND cmd_take_sample_calibration
{
	NUMBER          131;
	OPERATION       COMMAND;

	TRANSACTION
	{
		REQUEST{ }
		REPLY{ response_code, device_status	}
	}
	RESPONSE_CODES  {	 
				 0 , SUCCESS ,          [no_command_specific_errors] ; 
				 5 , MISC_ERROR ,       [too_few_data_bytes_recieved] ; 
				16, MODE_ERROR ,		[access_restricted];	
	}
}




//=============================================================================
//  MENU Bar
//=============================================================================

MENU Menu_Main_Specialist
{
  LABEL [main_menu];
  ITEMS {
    Menu_File,
    Menu_S_Device,
    Menu_S_View,
    Menu_Options,
    Menu_Help
  }
}

//-------------------------------------

MENU Menu_Main_Maintenance
{
  LABEL [main_menu];
  ITEMS	{
    Menu_File,
    Menu_M_Device,
    Menu_M_View,
    Menu_Options,
    Menu_Help
  }
}

//-----------------------------------------------------------------------------
//    Menu: File
//-----------------------------------------------------------------------------

MENU Menu_File
{
  LABEL [menu_File];
  ITEMS {
    std_Save,
    SEPARATOR,
    std_Eigenschaften,
    SEPARATOR,
    std_Print,
    std_PrintPreview,
    std_PrintSetup,
    std_PageSetup,
    std_Schriftfelder,
    SEPARATOR,
    std_Exit
  }
}

//-------------------------------------

MENU Menu_S_Device
{
  LABEL [menu_Device];
  ITEMS {
    std_CommWay,
    SEPARATOR,
    std_LoadinDevice,										
    std_LoadinPC,											
    SEPARATOR,
    loop_test,
    self_test,
    master_reset,
    configuration_flag_reset,
    SEPARATOR,
    meth_take_sample_calibration,
    meth_lab_sample_calibration,
    SEPARATOR,
    OnlineDialog_rerange,
    SEPARATOR,
    OnlineDialog_hart_comm
  }
}

MENU Menu_M_Device
{
  LABEL [menu_Device];
  ITEMS {
    std_LoadinDevice,										
    std_LoadinPC,											
    SEPARATOR,
    self_test,
  }
}

//-------------------------------------

MENU Menu_S_View
{
  LABEL [menu_View];
  ITEMS {
    OnlineWindow_display,
    OnlineWindow_S_diagnosis, 
    SEPARATOR,
    std_Funktionsleiste,
    std_Statuszeile,
    SEPARATOR,
    std_Update
  }
}

MENU Menu_M_View
{
  LABEL [menu_View];
  ITEMS {
    OnlineWindow_display,
    OnlineWindow_M_diagnosis, 
    SEPARATOR,
    std_Funktionsleiste,
    std_Statuszeile,
    SEPARATOR,
    std_Update
  }
}

//-------------------------------------

MENU Menu_Options
{
  LABEL [menu_Options];
  ITEMS {
    std_Einstellungen,
    std_Untereintraege
  }
}

//-------------------------------------

MENU Menu_Help
{
  LABEL [menu_Help];
  ITEMS {
    std_Hilfethemen,
    std_HilfeKontext,
    SEPARATOR,
    std_HilfeGeraet,
    SEPARATOR,
    std_HilfeEinfuehrung,
    std_HilfeErsteSchritte,
    SEPARATOR,
    std_Hilfebenutzen,
    std_Info
  }
}

//=============================================================================
//  Online-Windows
//=============================================================================

MENU OnlineWindow_display	// sollte vorhanden sein (Button: Mewertanzeige)
{
  LABEL [menu_dialog_display];
  ITEMS {
    Page_1_display		// sollte vorhanden sein (Button: Mewertanzeige)
  }
}

//-----------------------------------------------------------------------------

MENU Page_1_display		// sollte vorhanden sein (Button: Mewertanzeige)
{
  LABEL "Mettler Toledo - CondInd 7100e/2(X)H";
  ITEMS {
    analog_output_fixed1 (READ_ONLY),
    
    IF (selected_lin_log == 0){
	    BarVal_meas_display,
    }ELSE{
      	Val_messwert_display,
		selected_log_lr (READ_ONLY),
		selected_log_ur (READ_ONLY),
    }    	
    Val_temp_display,
    mA_output_current (READ_ONLY),
    var_cond,
	var_res,
    var_temp,
    device_status
  }
}

//-------------------------------------

MENU BarVal_meas_display
{
	LABEL	[menu_dialog_display_measure];
  	ITEMS{
					sensor_value, /*,main_unit, /**/    			    
			    	output_current_lrv		(READ_ONLY),
			    	output_current_urv		(READ_ONLY)
    }
}



//-------------------------------------
MENU Val_messwert_display
{
  LABEL	"PV"	"|de|PV";
  ITEMS {																										 
    sensor_value
  }
}

MENU Val_temp_display
{
  LABEL	"Temperature"	"|de|Temperatur";
  ITEMS {																										 
    sv_temp_value
  }
}

//-----------------------------------------------------------------------------

MENU OnlineWindow_S_diagnosis
{
  LABEL	[menu_dialog_diagnosis];
  ITEMS {
    OnlineWindow_diagnosis_device,
    Page_S_diagnosis_status
  }
}

MENU OnlineWindow_M_diagnosis
{
  LABEL	[menu_dialog_diagnosis];
  ITEMS {
    OnlineWindow_diagnosis_device,
    Page_M_diagnosis_status
  }
}

//-------------------------------------

MENU OnlineWindow_diagnosis_device
{
  LABEL	[menu_ident_device];
  ITEMS {
    tag			 (READ_ONLY),
// ??? removed by Siemens 03/29/99:    unit_tag		 (READ_ONLY),
    manufacturer_id	 (READ_ONLY),
    device_id		 (READ_ONLY),
    device_type		 (READ_ONLY),
    software_revision	 (READ_ONLY),
    hardware_revision	 (READ_ONLY),
    transmitter_revision (READ_ONLY),
    universal_revision	 (READ_ONLY)
  }
}

//-------------------------------------

MENU Page_S_diagnosis_status
{
  LABEL	"Errors && Smileys" "|de|Fehler && Smileys";
  ITEMS {
    xmtr_specific_status_0 (READ_ONLY),
    analog_output_fixed1	(READ_ONLY),
    function_check_status	(READ_ONLY),
    xmtr_specific_status_2	(READ_ONLY),
	analog_aoutput_saturated1 (READ_ONLY),
    configuration_flag_reset
  }
}

MENU Page_M_diagnosis_status
{
  LABEL	"Errors && Smileys" "|de|Fehler && Smileys";
  ITEMS {
    xmtr_specific_status_0 (READ_ONLY),
    analog_output_fixed1	(READ_ONLY),
    function_check_status	(READ_ONLY),
    xmtr_specific_status_2	(READ_ONLY),
	analog_aoutput_saturated1 (READ_ONLY),
    configuration_flag_reset
  }
}

//-------------------------------------

MENU OnlineDialog_rerange
{
  LABEL	[menu_window_lo_up_value];
  ITEMS {
    Page_rerange
  }
}

//-------------------------------------

MENU Page_rerange  //Messbereich Anfang/Ende
{
  LABEL	[menu_window_lo_up_value];
  
   ITEMS {

    selected_sensor,
    selected_pv_unit, 					     //selected_pv_unit,		 //primary_variable
	
	IF (selected_lin_log == 0){
	
	    output_current_lrv, 			     //  4 mA Eingabe
    	sensor_lower_limit (READ_ONLY),	     //max LOWER Limit	
	    output_current_urv, 			     // 20 mA Eingabe	
	    sensor_upper_limit (READ_ONLY),	     //max UPPER limit
	
	}ELSE{
	
	    selected_log_lr, 			         //  4 mA Eingabe
    	sensor_lower_limit (READ_ONLY),	     //max LOWER Limit	
	    selected_log_ur, 			         // 20 mA Eingabe	
	    sensor_upper_limit (READ_ONLY),	     //max UPPER limit	
	
	}

    sie_set    		
  }
}

//-------------------------------------

MENU OnlineDialog_hart_comm
{
  LABEL	[menu_HART_Comm];
  ITEMS {
    Page_polling_address,
    Page_request_response_preambles
  }
}

//-------------------------------------

MENU Page_polling_address
{
  LABEL	[menu_polling_address];
  ITEMS {
    polling_address,
    polling_address_set
  }
}

//-------------------------------------

MENU Page_request_response_preambles
{
  LABEL	[menu_request_response_preambles];
  ITEMS {
    response_preambles,
    request_preambles,
    sie_set
  }
}

//-----------------------------------------------------------------------------
//   Standard Methods
//-----------------------------------------------------------------------------

METHOD SEPARATOR
{
  LABEL	[menu_Separator];
  DEFINITION { }
}

//-------------------------------------

METHOD std_Save
{
  LABEL	[menu_File_Save];
  DEFINITION { }
}

//-------------------------------------

METHOD std_Eigenschaften
{
  LABEL	[menu_File_Properties];
  DEFINITION { }
}

//-------------------------------------

METHOD std_Print
{
  LABEL	[menu_File_Print];
  DEFINITION { }
}

//-------------------------------------

METHOD std_PrintPreview
{
  LABEL	[menu_File_PrintPreview];
  DEFINITION { }
}

//-------------------------------------

METHOD std_PrintSetup
{
  LABEL	[menu_File_PrintSetup];
  DEFINITION { }
}

//-------------------------------------

METHOD std_PageSetup
{
  LABEL	[menu_File_PageSetup];
  DEFINITION { }
}

//-------------------------------------

METHOD std_Schriftfelder
{
  LABEL	[menu_File_Labels];
  DEFINITION { }
}

//-------------------------------------

METHOD std_Exit
{
  LABEL	[menu_File_Exit];
  DEFINITION { }
}

//-------------------------------------

METHOD std_CommWay
{
  LABEL	[menu_Device_CommWay];
  DEFINITION { }
}

//-------------------------------------

METHOD std_LoadinDevice
{
  LABEL	[menu_Device_LoadinDevice];
  DEFINITION { }
}

//-------------------------------------

METHOD std_LoadinPC
{
  LABEL	[menu_Device_LoadinPC];
  DEFINITION { }
}

//-------------------------------------

METHOD std_Funktionsleiste
{
  LABEL	[menu_View_Toolbar];
  DEFINITION { }
}

//-------------------------------------

METHOD std_Statuszeile
{
  LABEL	[menu_View_Statusbar];
  DEFINITION { }
}

//-------------------------------------

METHOD std_Update
{
  LABEL	[menu_View_Update];
  DEFINITION { }
}

//-------------------------------------

METHOD std_Einstellungen
{
  LABEL	[menu_Options_Properties];
  DEFINITION { }
}

//-------------------------------------

METHOD std_Untereintraege
{
  LABEL	[menu_Options_Subitems];
  DEFINITION { }
}


//=============================================================================
//  Table
//=============================================================================

MENU Table_Main_Specialist
{
  LABEL "Mettler Toledo - CondInd 7100e/2(X)H";
  ITEMS {
    Tab_s_identification,
    Tab_s_inputs,
    Tab_s_outputs,
    Tab_s_calibration
  }
}

//-------------------------------------

MENU Tab_s_identification
{
  LABEL [menu_ident];
  ITEMS {
    Tab_s_opunit,
    Tab_s_device
  }
}

//-------------------------------------

MENU Tab_s_opunit
{
  LABEL [menu_ident_opunit];
  ITEMS {
    tag,
    descriptor,
    message
  }
}

//-------------------------------------

MENU Tab_s_device
{
  LABEL [menu_ident_device];
  ITEMS	{
    manufacturer_id,
    universal_revision,
    transmitter_revision,
    software_revision,
    hardware_revision,
    device_id,
    device_type,
    device_flags,
    physical_signaling_code,
    final_assembly_number,
    date
  }
}

//-------------------------------------

MENU Tab_s_inputs
{
  LABEL "Inputs" "|de|Eingang";
  ITEMS {
	selected_sensor,
    var_cell_factor,           
    var_sensor_factor_sfc,                    
    selected_pv_unit,
	selected_conc_sol,
    selected_temp_unit,
	selected_temp_sensor
  }
}

//-------------------------------------

MENU Tab_s_outputs
{
  LABEL "Outputs" "|de|Ausgang";
  ITEMS	{
    selected_lin_log,       //Lin Log
    selected_log_lr,		// Log Anfang
    output_current_lrv,		// Lin Anfang (4mA)
	selected_log_ur,		// Log Ende
    output_current_urv,		// Lin Ende  (20mA)
	selected_TC_func,       // Auswahl TC 
	var_TC_lin,				// Einstellung TC Lin Koeffizient
	var_filter_1,			// Filterzeitkonstant
    selected_22mA,			// 22mA bei Fehler
	selected_hold_last_fix, // Fix - Last
    selected_hold_fix,		// HOLD Last/Fix
    var_fix_value			// HOLD-Fix Wert
					   
	//mA_output_current,
	//percent_of_range

  }
}

//-------------------------------------
MENU Tab_s_calibration
{
  LABEL "Alarm settings"	"|de|Alarm Einstellungen";
  ITEMS	{
    selected_senso_check,
    var_alarmdelay_1,
	selected_holdLED
  }
}



//-----------------------------------------------------------------------------

MENU Table_Main_Maintenance
{
  LABEL "Mettler Toledo - CondInd 7100e/2(X)H";
  ITEMS {
    Tab_m_identification,
    Tab_m_inputs,
    Tab_m_outputs,
    Tab_m_calibration,
  }
}

//-------------------------------------

MENU Tab_m_identification
{
  LABEL [menu_ident];
  ITEMS {
    Tab_s_opunit,
    Tab_s_device
  }
}

//-------------------------------------

MENU Tab_m_opunit
{
  LABEL [menu_ident_opunit];
  ITEMS {
    tag (READ_ONLY),
    descriptor,
    message
  }
}

//-------------------------------------

MENU Tab_m_device
{
  LABEL [menu_ident_device];
  ITEMS	{
    manufacturer_id,
    universal_revision,
    transmitter_revision,
    software_revision,
    hardware_revision,
    device_id,
    device_type,
    device_flags,
    physical_signaling_code,
    final_assembly_number,
    date
  }
}

//-------------------------------------

MENU Tab_m_inputs
{
  LABEL "Inputs" "|de|Eingang";
  ITEMS {
	selected_pv_unit (READ_ONLY),
	selected_conc_sol (READ_ONLY),
    selected_temp_unit (READ_ONLY),
	selected_temp_sensor (READ_ONLY)  }
}

//-------------------------------------

MENU Tab_m_outputs
{
  LABEL "Outputs" "|de|Ausgang";
  ITEMS	{
    output_current_lrv (READ_ONLY),		// Anfang (4mA)
    output_current_urv (READ_ONLY),		// Ende  (20mA)
	var_filter_1 (READ_ONLY),
    selected_22mA (READ_ONLY),		// 22mA bei Fehler
    selected_hold_fix (READ_ONLY),		// HOLD Last/Fix
    var_fix_value (READ_ONLY)		// HOLD-Fix Wert
  }
}

//-------------------------------------
MENU Tab_m_calibration
{
  LABEL "Alarm settings"	"|de|Alarm Einstellungen";
  ITEMS	{
    selected_senso_check (READ_ONLY),
    var_alarmdelay_1 (READ_ONLY),
	selected_holdLED (READ_ONLY)
  }
}






//=============================================================================
//  Methods
//=============================================================================

METHOD sie_set			// Transmit-Button
{
  LABEL	[transfer];
  HELP	[transfer_help];
  CLASS INPUT;
  DEFINITION { }
}

//-------------------------------------

METHOD polling_address_set
{
  LABEL	[transfer];
  HELP 	[transfer_help];
  CLASS INPUT;
  DEFINITION {
    ACKNOWLEDGE( [message_polling_address] );
  }
}






/*------------------------------------------------------------------------------------*/
/*	methods of value transmitter_variables 			   								  */
/* Warntext wird ausgegeben da die Wert sofort im Gert gendert werden, fr AMS	  */
/* notwendig und im HC275 sinnvoll, der Anwender muss nicht extra <send> drcken 	  */
/*------------------------------------------------------------------------------------*/

#define meth_sample_check_e2212 \
		if( !e2212_meth ){ \
			ACKNOWLEDGE( "Sample calibration via HART not available for device software before V4.0. \n\n Press OK to finish" \
						 "|de|Produktkalibrierung ber HART-Kommunikation erst verfgbar ab Softwareversion 4.0. \n\n Drcken Sie OK zum Beenden"  );\
			process_abort(); \
		}

#define meth_head( _check_e ) \
		  		char	status [STATUS_SIZE]; \
				char  disp_string1 [60];    \
				int   slen1;					 \
				int	selc;						 \
				long	ids [2];					 \
				int 	sec;						 \
				slen1 = 60;						 \
				if( _check_e != 0 ){ meth_sample_check_e2212 } \
				get_dictionary_string (remove_loop_from_auto, disp_string1, slen1); \
				ACKNOWLEDGE (disp_string1); \
				add_abort_method (return_to_normal);

#define meth_definition_var( _transvar, _var, _label, _meth ) \
				{	meth_head( 0 ) \
					iassign( transmitter_variable_index, _transvar ); \
					send_trans( 128, 1, status ); \
					GET_DEV_VAR_VALUE ( _label, _var ); \
					IGNORE_ALL_RESPONSE_CODES (); \
					iassign( transmitter_variable_index, _transvar ); \
					send_trans( 129, 1, status ); \
					if (status [STATUS_RESPONSE_CODE]){ \
						display_response_status (132, status [STATUS_RESPONSE_CODE]); \
						ACKNOWLEDGE( "WARNING: Configuration was abborted!\n \nACTION: Repeat this step." \
						"|de|WARNUNG: Konfiguration wurde abgebrochen!\n Hinweis:Wiederholung dieses Schrittes!" ); \
					} \
					process_abort(); \
				}
                

METHOD loop_test
{
  LABEL	[loop_test];
  HELP	[loop_test_help];
  DEFINITION {
    char status[STATUS_SIZE];
    int choice;
    long var_id[1];
    int use_abort_method;
    char disp_string1[60];
    char disp_string2[60];
    int slen1;
    int slen2;

    slen1 = 60;
    slen2 = 60;
    get_dictionary_string( remove_loop_from_auto, disp_string1, slen1 );
    ACKNOWLEDGE( disp_string1 );
    add_abort_method( return_to_normal );

    IGNORE_ALL_RESPONSE_CODES( );

    use_abort_method = 0;
    do {
     	 get_dictionary_string( choose_analog_output_level, disp_string1, slen1 );
     	 get_dictionary_string( choices_4_20_other_end, disp_string2, slen2 );
      	choice = SELECT_FROM_LIST( disp_string1, disp_string2 );
      
      switch( choice ) {
							case 0:		assign_float( primary_analog_current_value, 4.0 ); 
                                        break;
							
							case 1:		assign_float( primary_analog_current_value, 20.0 ); 
										break;

							case 2:		get_dictionary_string( loop_output, disp_string1, slen1 );
										GET_DEV_VAR_VALUE( disp_string1, primary_analog_current_value ); 
										break;

							case 3:
				
							default:	process_abort( );
							break;
      }

      send( 40, status );
      
      if( !use_abort_method ) {
				if( (status[STATUS_RESPONSE_CODE] != 0) && (status[STATUS_RESPONSE_CODE] != 3) && (status[STATUS_RESPONSE_CODE] != 4) ) {
					  display_response_status( 40, status[STATUS_RESPONSE_CODE] );
					  get_dictionary_string( abort_last_error, disp_string1, slen1 );
					  DELAY( 2, disp_string1 );
					  process_abort( );
				}
				remove_abort_method( return_to_normal );
				add_abort_method( leave_fixed_current_mode );
				use_abort_method = 1;
      }

      if( status[STATUS_RESPONSE_CODE] ) {
				display_response_status( 40, status[STATUS_RESPONSE_CODE] );
				if( (status[STATUS_RESPONSE_CODE] != 3) && (status[STATUS_RESPONSE_CODE] != 4) ) {
					  get_dictionary_string( abort_last_error, disp_string1, slen1 );
					  DELAY( 2, disp_string1 );
					  process_abort( );
				}
      }else {
				var_id[0] = VARID( primary_analog_current_value ); 
				get_dictionary_string( fld_dev_otpt_fixed, disp_string1, slen1 );
				acknowledge( disp_string1, var_id );
      }

    } while( choice < 3 );
	    process_abort( );
  }
}
//-------------------------------------

METHOD leave_fixed_current_mode
{
  LABEL	[leaving_fixed_current_mode];
  HELP	[leaving_fixed_current_mode_help_2];
  DEFINITION {
    char status[STATUS_SIZE];
    long var_id[1];
    char disp_string1[60];
    int slen1;

    slen1 = 60;

    assign_float( primary_analog_current_value, 0.0 );  
    IGNORE_ALL_RESPONSE_CODES( ); 
    do {
      get_dictionary_string( return_fld_dev_to_orig_otpt, disp_string1, slen1 );
      DELAY( 3, disp_string1 );
      send( 40, status );
      if( status[STATUS_RESPONSE_CODE] ) {
	display_response_status( 40, status[STATUS_RESPONSE_CODE] );
      }
    } while( status[STATUS_RESPONSE_CODE] );
    get_dictionary_string( loop_may_be_returned_to_auto, disp_string1, slen1 );
    ACKNOWLEDGE( disp_string1 );
  }
}




//-----------------------------------------------------------------------------

METHOD self_test
{
  LABEL	[selftest];
  HELP	[selftest_help];
  CLASS INPUT;
  DEFINITION {
    int choice;
    char status[3];
    char disp_string1[60];
    char disp_string2[60];
    int slen1;
    int slen2;
		
    slen1 = 60;
    slen2 = 60;
		
    get_dictionary_string( selftest_execute, disp_string1, slen1 );
    get_dictionary_string( yes_no, disp_string2, slen2 );
		
    choice = SELECT_FROM_LIST( disp_string1, disp_string2 );
    if( choice == 0 ) {
      add_abort_method( return_to_normal );
      IGNORE_ALL_RESPONSE_CODES( );
      send( 41, status );
      if( (status[STATUS_RESPONSE_CODE] > 1) || status[STATUS_COMM_STATUS] || status[STATUS_DEVICE_STATUS] ) {
	if( status[STATUS_RESPONSE_CODE] > 1 ) {
	  display_response_status( 41, status[STATUS_RESPONSE_CODE] );
	}
	if( status[STATUS_COMM_STATUS] > 1 ) { // COMM_STATUS > 1 damit nur eine Fehlermeldung bei Kommunikationsfehlern ausgegeben wird
	  display_comm_status( status[STATUS_COMM_STATUS] );
	}
	if( status[STATUS_DEVICE_STATUS] ) {
	  display_device_status( status[STATUS_DEVICE_STATUS] );
	}
	process_abort( );
      }
      else {
	get_dictionary_string( selftest_ok, disp_string1, slen1 );
	ACKNOWLEDGE( disp_string1 );
      }
    }
  }
}

//-----------------------------------------------------------------------------

METHOD master_reset
{
  LABEL	[master_reset];
  HELP	[master_reset_help];
  CLASS INPUT;
  DEFINITION {
    int choice;
    char status[3];
    char disp_string1[60];
    char disp_string2[60];
    int slen1;
    int slen2;

    slen1 = 60;
    slen2 = 60;

    get_dictionary_string( master_reset_execute, disp_string1, slen1 );
    get_dictionary_string( yes_no, disp_string2, slen2 );

    choice = SELECT_FROM_LIST( disp_string1, disp_string2 );
    if( choice == 0 ) {
      add_abort_method( return_to_normal );
      IGNORE_ALL_RESPONSE_CODES( );
      send( 42, status );
      if( (status[STATUS_RESPONSE_CODE] > 1)|| status[STATUS_COMM_STATUS] || status[STATUS_DEVICE_STATUS] ) {
	if( status[STATUS_RESPONSE_CODE] > 1 ) {
	  display_response_status(41, status[STATUS_RESPONSE_CODE]);
	}
	if( status[STATUS_COMM_STATUS] ) {
	  display_comm_status(status[STATUS_COMM_STATUS]);
	}
	if( status[STATUS_DEVICE_STATUS] ) {
	  display_device_status(status[STATUS_DEVICE_STATUS]);
	}
	process_abort( );
      }
      else {
	get_dictionary_string( master_reset_ok, disp_string1, slen1 );
	ACKNOWLEDGE( disp_string1 );
      }
    }
  }
}

//-----------------------------------------------------------------------------

METHOD configuration_flag_reset
{																																 
  LABEL	[configuration_flag_reset];
  HELP	[configuration_flag_reset_help];
  CLASS INPUT;
  DEFINITION {
    int choice;
    char disp_string1[60];
    char disp_string2[60];
    int slen1;
    int slen2;

    slen1 = 60;
    slen2 = 60;

    get_dictionary_string( configuration_flag_reset_execute, disp_string1, slen1 );
    get_dictionary_string( yes_no, disp_string2, slen2 );

    choice = SELECT_FROM_LIST( disp_string1, disp_string2 );
    if( choice == 0 ) {
      send_command( 38 );
    }
  }
}


#define 	text_sample_abort "WARNING: Sample calibration was abborted!\n \nACTION: Repeat this step.""|de|WARNUNG: Produktkalibrierung wurde abgebrochen!\n\nHINWEIS:Wiederholen Sie diesen Schritt."

#define 	text_sample_fin "Press OK finish""|de|Drcken Sie OK zum Beenden"	

METHOD meth_take_sample_calibration
{
/* HC275:			"123456789012345678" */
	LABEL          "Take Sample" "|de|Produktkalibrierung - Probenentnahme";
	HELP           "Product Calibration Sequence Take Sample" "|de|Produktkalibrierung Schritt 1 Probenentnahme";
	DEFINITION {
		char   status[STATUS_SIZE] ;
		long   ids[5];
        float  fval, fval2;

		ids[0] = VARID( sensor_value ) ;
		ids[1] = VARID( sensor_units ) ;
		ids[2] = VARID( sv_temp_value ) ;
		ids[3] = VARID( sv_temp_units ) ;
        ids[4] = VARID( var_cond ) ;

		meth_sample_check_e2212
		/* e2211 */
		/*----------------*/  

		
		if ((int_value(sensor_units) == UNITS_CODE_PERC) || (int_value(sensor_units) == UNITS_CODE_SAL)) {
			ACKNOWLEDGE ("Product Calibration in measure Mode Concentration or SAL, not allowed. Please Choose another measure unit." "|de|Produktkalibrierung im Messmodus Konzentration oder Salinitt ist nicht erlaubt. Bitte whlen Sie eine andere Messeinheit.");
			process_abort;
		}
		

			ACKNOWLEDGE("Take a sample from the process and store the currently measured value."
						"\n"
						"Note that the meassured value of the sample is temperature dependent."
						" \n" 
						"Therefore, laboratory measurement should be performed at the sample temperature shown in the display, if possible."
						"\n"
						"As far as possible, you should transport the sample in an insulated container (Dewar)."
						"\n"
						"The meassured value may also be altered due to escaping of volatile substances.\nPress OK to show measured value."

						"|de|Entnehmen Sie dem Proze eine Probe und messen Sie diese, z.B. im Labor."
						"\n"
						"Beachten Sie, da der entnomme Wert temperaturbhngig ist."
						"\n"
						"Die Messung im Labor sollte daher mglichst bei der im Display angezeigten Probentemperatur erfolgen."
						"\n"
						"Transportieren Sie die Probe mglichst in einem Isoliergef (Dewar)."
						"\n" 
						"Der gemessene Wert der Probe kann auch durch Entweichen flchtiger Substanzen verflscht werden."
						"\n"
						"Drcken Sie OK um den gemessenen Wert zu erhalten.");

		/*----------------*/
		send (48, status) ;
	   if( int_value(function_check_status) & 0x03 ){
		/*----------------*/

        ACKNOWLEDGE("WARNING: Device is in calibration or configuration, no sample calibration allowed!"
						"\n\n"
						"ACTION: Leave device calibration or configuration and repeat this step."
						"\n\n"
						"Press OK finish" 
						"|de|WARNUNG: Das Feldgert befindet sich innerhalb einer Kalibrierung oder Konfigurierung, keine Probenentnahme erlaubt!"
						"\n\n"
						"HINWEIS: Verlassen Sie die Kalibrierung oder Konfigurierung und wiederholen Sie diesen Schritt."
						"\n\n"
						"Drcken Sie OK zum Beenden.");

        /*----------------*/
		}else{
	   	if( (int_value(function_check_status) & 0x04) ){
		/*----------------*/

			ACKNOWLEDGE("WARNING: Sample was already taken. If you call <Take Sample> twice then the first sample will be lost!"
						" \n\n"
						"ACTION: Confirm discarding the first sample."
						"\n\n"
						"Press OK to discard the first sample"
						"|de|WARNUNG: Es wurde bereits eine Probe entnommen! Wenn Sie (Produktkalibrierung - Probenentnahme) doppelt drcken, wird der zuerst entnommene Probenwert verworfen!"
						"\n\n"
						"HINWEIS: Besttigen Sie, das der zuletzt entnomme Probenwert verworfen werden kann."
						"\n\n"
						"Drcken Sie OK um den zuletzt entnommen Probenwert zu verwerfen");


			}

            display("Actual measured value: %{4} mS      Temperature: %{2} %{3}" "|de|Aktueller Messwert: %{4} mS    Temperatur: %{2} %{3}",ids); 

			IGNORE_ALL_RESPONSE_CODES () ;
			send (131, status) ;
			if (status [STATUS_RESPONSE_CODE]){
				display_response_status (131, status [STATUS_RESPONSE_CODE]) ;


				ACKNOWLEDGE("Press OK finish\n\n WARNING: Sample calibration was abborted!"
							"\n\n"
							"ACTION: Repeat this step."
							"|de|Drcken Sie OK zum Beenden. WARNUNG: Produktkalibrierung wurde abgebrochen!"
							"\n\n"
							"HINWEIS:Wiederholen Sie diesen Schritt.");

			}
		} /*else */
		process_abort();
	}
}

/* -------------------------------------------------------------------------------------------------------------------------------- */
/* Produktkalibrierung Schritt 2
-------------------------------------------------------------------------------------------------------------------------------- */

METHOD meth_lab_sample_calibration
{
/* HC275:			"123456789012345678" */
	LABEL          "Input Lab Sample" "|de|Produktkalibrierung - Vergleichswerteingabe";
	HELP           "Product Calibration Sequence Input Lab Sample" "|de|Produktkalibrierung Schritt2 Vergleichswerteingabe";
	DEFINITION{
		char   status [STATUS_SIZE] ;
	
		float  fval, fval2;

		long   ids[2];

		ids[0] = VARID(sensor_units) ;
		ids[1] = VARID(var_cond) ;

		meth_sample_check_e2212



			ACKNOWLEDGE("Enter the measured lab value. The new zero point is automatically calculated and stored."
						"\n\n"
						"The values obtained by sample calibration are always accepted, even if they are outside calibration limits!"
						"\n\n"
						"Press OK to enter lab value"

						"|de|Geben Sie den gemessenen Wert der Probe ein. Der neue Meketten-Nullpunkt wird automatisch berechnet und gespeichert."
						"\n\n"
						"Die Werte bei der Probenkalibrierung werden immer bernommen, auch wenn sie auerhalb des Cal-Toleranzbandes liegen!"
						"\n\n"
						"Drcken Sie OK um den Vergleichswert einzugeben");


		/*----------------*/
		send (48, status) ;
	   if( int_value(function_check_status) & 0x03 ){
		/*----------------*/

			ACKNOWLEDGE( "WARNING: Device is in calibration or configuration, no sample calibration allowed"
						 "\n\n" 
						 "ACTION: Leave device calibration or configuration and repeat this step."
						 "\n\n"
						 "Press OK finish"
						
						"|de|WARNUNG: Das Feldgert befindet sich innerhalb einer Kalibrierung oder Konfigurierung, keine Probenentnahme erlaubt!"
						"\n\n"
						"HINWEIS: Verlassen Sie die Kalibrierung oder Konfigurierung und wiederholen Sie diesen Schritt"
						"\n\n"
						"Drcken Sie OK zum Beenden.");

		/*----------------*/
		}else{
	   	if( !(int_value(function_check_status) & 0x04) ){
		/*----------------*/
 

			ACKNOWLEDGE("WARNING: No sample was taken, no sample calibration allowed"
						"\n\n"
						"ACTION: First call <Take Sample> and then <Input Lab Sample>."
						"\n\n"
						"Press OK finish"
						
						"|de|WARNUNG: Es wurde keine Probe entnommen, Produktkalibrierung nicht zulssig!"
						"\n\n"
						"HINWEIS: Als Erstes mssen Sie <Produktkalibrierung - Probenentnahme> und dann <Produktkalibrierung - Vergleichswerteingabe> aufrufen."
						"\n\n"
						"Drcken Sie OK zum Beenden.");

		/*----------------*/
		 
			}else{
                    fval = fvar_value (var_cond);
					get_local_var_value ("Enter the lab value (mS) : " "|de|Eingabe des Vergleichwertes (mS) : ", ids, fval) ;  /* uS,mS,Sm */
                   
				IGNORE_ALL_RESPONSE_CODES () ;
                assign_float (var_sample_cal, fval);
				iassign( transmitter_variable_index, transvar_sample_cal );
				send_trans (129, 1, status);
				if (status [STATUS_RESPONSE_CODE]){
					display_response_status (129, status [STATUS_RESPONSE_CODE]) ;
		/*----------------*/


					ACKNOWLEDGE("WARNING: Sample calibration was abborted!\n \nACTION: Repeat this step"
								"\n\n"
								"Press OK finish"

								"|de|WARNUNG: Produktkalibrierung wurde abgebrochen!\n\nHINWEIS:Wiederholen Sie diesen Schritt."
								"\n\n"
								"Drcken Sie OK zum Beenden.");
		/*----------------*/
				}
			}
		}
		process_abort();
	}
}
